package xgs.net.commons;

import com.jfinal.config.Constants;
import com.jfinal.config.Handlers;
import com.jfinal.config.Interceptors;
import com.jfinal.config.Plugins;
import xgs.net.init.XgsConfig;
import xgs.net.interceptors.*;
import xgs.net.plugin.IocPlugin;
import xgs.net.utils.MyJsonFactory;

import java.io.File;
import java.net.URL;

public class ApiConfig extends XgsConfig
{
    public void constant(Constants me) {
        me.setJsonFactory(new MyJsonFactory());
    }
    
    public void plugin(Plugins me) {
        String[] pkgs = { "xgs.net" };
        IocPlugin ioc = new IocPlugin(pkgs);
        me.add(ioc);
        this.routes.add(ioc.getRoutes());
    }
    
    private File getFile(String fileName) {
        final URL url = this.getClassLoader().getResource(fileName);
        return new File(url.getFile());
    }
    
    private ClassLoader getClassLoader() {
        final ClassLoader ret = Thread.currentThread().getContextClassLoader();
        return (ret != null) ? ret : this.getClass().getClassLoader();
    }
    
    public void interceptor(Interceptors me) {
        me.addGlobalActionInterceptor(new DomainInterceptor());
        me.addGlobalActionInterceptor(new RestFulInterceptor());
//        me.addGlobalActionInterceptor(new ValidationInterceptor());
//        me.addGlobalActionInterceptor(new AcademyInterceptor());
        me.addGlobalActionInterceptor(new JsonInterceptor());
        //me.addGlobalActionInterceptor(new AreaInterceptor());
    }
    
    public void handler(final Handlers me) {
    }
}
