package xgs.net.controller;


import com.jfinal.core.Controller;
import com.jfinal.plugin.redis.Cache;
import com.jfinal.plugin.redis.Redis;

import xgs.net.entity.Msg;

import xgs.net.entity.OperaterEntity;
import xgs.net.entity.PageEntity;
import xgs.net.interceptors.ValidationInterceptor;
//import xgs.net.model.TbUser;
import xgs.net.token.JwtToken;
import xgs.net.utils.WebUtils;


public class BaseController extends Controller
{
    private static final String memberSession = "group";
    private static final int expire = 7*60*60*24;
    protected static Cache redis;
    
    protected String generateKey(String JwtToken) {
        return memberSession + "-" + JwtToken;
    }
    
//    protected void cacheToken(String JwtToken, TbUser user) {
//        BaseController.redis.setex(this.generateKey(JwtToken), expire, user);
//    }
    
    protected PageEntity getPage() {
        PageEntity entity = new PageEntity();
        entity.setPageNo(this.getParaToInt("pageNumber", 1));
        entity.setPageSize(this.getParaToInt("pageSize", 10));
        return entity;
    }
    
//    public TbUser getUser() {
//        try{
//            String token = this.getRequest().getHeader(ValidationInterceptor.XToken);
//            if(token == null) return null;
//            String key = this.generateKey(token);
//            TbUser user = BaseController.redis.get(this.generateKey(token));
//            if (user != null) {
//                redis.expire(key, expire);
//            }
//            return user;
//        }catch (Exception e){
//            return null;
//        }
//    }
//
    protected void renderMyJson(Msg msg) {
        this.renderJson(msg);
    }
    
//    protected OperaterEntity getOperaterEntity() {
//        OperaterEntity operaterEntity = new OperaterEntity();
//        operaterEntity.setOperateTime(System.currentTimeMillis());
//        operaterEntity.setOperateIp(WebUtils.getIP(this.getRequest()));
//        operaterEntity.setOperator(this.getUser().getUserNick());
//        operaterEntity.setOperatorId(this.getUser().getId());
//        return operaterEntity;
//    }

    protected void cleanToken(){
        String token = this.getRequest().getHeader(ValidationInterceptor.XToken);
        String key = this.generateKey(token);
        redis.del(key);
    }
//
//    protected Msg setToken(TbUser user) {
//        String token = JwtToken.createToken(user.getId());
//        this.cacheToken(token, user);
//        user.put(ValidationInterceptor.XToken, token);
//        Msg msg = new Msg();
//        user.setSalt(null);
//        user.setPwd(null);
//        user.setStatus(null);
//        user.removeNullValueAttrs();
//        msg.setData(user);
//        return msg;
//    }

    static {
        redis = Redis.use();
    }
}
