package xgs.net.dev;

import com.jfinal.core.JFinalFilter;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.servlet.FilterHolder;
import org.eclipse.jetty.webapp.WebAppContext;

import javax.servlet.DispatcherType;
import java.util.EnumSet;

public class JettyStartter implements Startter
{
    @Override
    public void start() {
        final EnumSet<DispatcherType> all = EnumSet.of(DispatcherType.ASYNC, DispatcherType.ERROR, DispatcherType.FORWARD, DispatcherType.INCLUDE, DispatcherType.REQUEST);
        final Server server = new Server(JettyStartter.prop.getInt("system.start.port", 80));
        try {
            final WebAppContext context = new WebAppContext("/", "/");
            final FilterHolder filter = new FilterHolder(new JFinalFilter());
            filter.setInitParameter("configClass", JettyStartter.prop.get("system.start.configClazz"));
            context.addFilter(filter, "/*", all);
            server.setHandler(context);
            server.start();
            server.join();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
