package xgs.net.validation;

import com.jfinal.plugin.IPlugin;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import xgs.net.searcher.ClassSearcher;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.utils.ValidatePool;

import java.io.InputStream;
import java.util.Set;

public class ValidationPluign implements IPlugin
{
    Logger logger;
    private String[] pkgs;
    private InputStream file;
    
    public ValidationPluign(final InputStream file, final String... pkgs) {
        this.logger = LoggerFactory.getLogger((Class)ValidationPluign.class);
        this.pkgs = pkgs;
        this.file = file;
    }
    
    public boolean start() {
        ValidationUtils.init(this.file);
        final Set<Class<?>> classes = (Set<Class<?>>)ClassSearcher.getClasses(this.pkgs, new Class[] { Validation.class });
        for (final Class clazz : classes) {
            final Validation validation = (Validation) clazz.getAnnotation(Validation.class);
            if (validation != null) {
                try {
                    ValidatePool.init(validation.value(), (XgsValidation) clazz.newInstance());
                }
                catch (Exception e) {
                    e.printStackTrace();
                    this.logger.error("\u521d\u59cb\u5316\u68c0\u9a8c\u63d2\u4ef6\u5931\u8d25", (Throwable)e);
                    return false;
                }
            }
        }
        return true;
    }
    
    public boolean stop() {
        return true;
    }
}
