package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

import java.math.BigInteger;

@Validation("bigint")
public class BigIntValidation extends AbstractValidation
{
    @Override
    public void executor(final ModelEntity me, final FieldEntity fe, final ValidationEntity ve, final Model model, final ValidationErrorMsg errorMsg) {
        if (model.get(fe.getField()) == null) {
            return;
        }
        final Object obj = model.get(fe.getField());
        if (obj instanceof Long || obj instanceof BigInteger) {
            return;
        }
        errorMsg.getErrors().add(ve.getMessage());
    }
}
