package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Validation("email")
public class EmailValidation extends AbstractValidation
{
    private static final String regex = "^[a-z0-9\\u007F-\\uffff!#$%&'*+\\/=?^_`{|}~-]+(?:\\.[a-z0-9\\u007F-\\uffff!#$%&'*+\\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z]{2,}$";
    private static final Pattern pattern;
    
    @Override
    public void executor(final ModelEntity me, final FieldEntity fe, final ValidationEntity ve, final Model model, final ValidationErrorMsg errorMsg) {
        if (!ve.getEmail()) {
            return;
        }
        if (model.get(fe.getField()) == null) {
            return;
        }
        final String value = this.getStr(model, fe);
        final Matcher matcher = EmailValidation.pattern.matcher(value.toLowerCase());
        if (!matcher.find()) {
            errorMsg.getErrors().add(ve.getMessage());
        }
    }
    
    static {
        pattern = Pattern.compile("^[a-z0-9\\u007F-\\uffff!#$%&'*+\\/=?^_`{|}~-]+(?:\\.[a-z0-9\\u007F-\\uffff!#$%&'*+\\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z]{2,}$");
    }
}
