package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Validation("ipv4")
public class Ipv4Validation extends AbstractValidation
{
    private static final String regex = "^(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})$";
    private static final Pattern pattern;
    
    @Override
    public void executor(final ModelEntity me, final FieldEntity fe, final ValidationEntity ve, final Model model, final ValidationErrorMsg errorMsg) {
        if (model.get(fe.getField()) == null) {
            return;
        }
        final Matcher matcher = Ipv4Validation.pattern.matcher(this.getStr(model, fe).toLowerCase());
        if (!matcher.find()) {
            errorMsg.getErrors().add(ve.getMessage());
        }
    }
    
    static {
        pattern = Pattern.compile("^(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})$");
    }
}
