package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Validation("mobile")
public class MobileValidation extends AbstractValidation
{
    private static final String regex = "^((13[0-9])|(14[5,7])|(15[^4,\\\\D])|(17[0,1,3,6-8])|(18[0-9])|(19[8,9])|(166))[0-9]{8}$";
    private static final Pattern pattern;
    
    @Override
    public void executor(final ModelEntity me, final FieldEntity fe, final ValidationEntity ve, final Model model, final ValidationErrorMsg errorMsg) {
        if (model.get(fe.getField()) == null) {
            return;
        }
        if (!ve.getMobile()) {
            return;
        }
        final String value = this.getStr(model, fe);
        final Matcher matcher = MobileValidation.pattern.matcher(value);
        if (!matcher.find()) {
            errorMsg.getErrors().add(ve.getMessage());
        }
    }
    
    static {
        pattern = Pattern.compile("^((13[0-9])|(14[5,7])|(15[^4,\\\\D])|(17[0,1,3,6-8])|(18[0-9])|(19[8,9])|(166))[0-9]{8}$");
    }
}
