package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

import java.math.BigDecimal;
import java.math.BigInteger;

@Validation("number")
public class NumberValidation extends AbstractValidation
{
    @Override
    public void executor(final ModelEntity me, final FieldEntity fe, final ValidationEntity ve, final Model model, final ValidationErrorMsg errorMsg) {
        if (model.get(fe.getField()) == null) {
            return;
        }
        final String field = fe.getField();
        final Object _obj = model.get(field);
        if (_obj instanceof BigDecimal || _obj instanceof Float || _obj instanceof Double || _obj instanceof Integer || _obj instanceof Long || _obj instanceof BigInteger) {
            return;
        }
        errorMsg.getErrors().add(ve.getMessage());
    }
}
