package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

@Validation("string")
public class StringValidate extends AbstractValidation
{
    @Override
    public void executor(final ModelEntity me, final FieldEntity fe, final ValidationEntity ve, final Model model, final ValidationErrorMsg errorMsg) {
        try {
            final String value = model.getStr(fe.getField());
            if (value == null || value.length() == 0) {
                return;
            }
            if (ve.getMax() != null && value.length() > ve.getMax()) {
                errorMsg.getErrors().add(ve.getMessage());
            }
            else if (ve.getMin() != null && value.length() < ve.getMin()) {
                errorMsg.getErrors().add(ve.getMessage());
            }
            else if (ve.getLen() != null && value.length() != ve.getLen()) {
                errorMsg.getErrors().add(ve.getMessage());
            }
        }
        catch (Exception e) {
            errorMsg.getErrors().add(ve.getMessage());
        }
    }
}
