package xgs.net.validation.impl;

import com.jfinal.plugin.activerecord.Model;
import xgs.net.validation.annotation.Validation;
import xgs.net.validation.entity.FieldEntity;
import xgs.net.validation.entity.ModelEntity;
import xgs.net.validation.entity.ValidationEntity;
import xgs.net.validation.entity.ValidationErrorMsg;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Validation("url")
public class UrlValidation extends AbstractValidation
{
    private static final String regex = "http(s)?://([\\w-]+\\.)+[\\w-]+(/[\\w- ./?%&=]*)?";
    private static final Pattern pattern;
    
    @Override
    public void executor(ModelEntity me, FieldEntity fe, ValidationEntity ve, Model model, ValidationErrorMsg errorMsg) {
        if (model.get(fe.getField()) == null) {
            return;
        }
        final Matcher matcher = UrlValidation.pattern.matcher(this.getStr(model, fe).toLowerCase());
        if (!matcher.find()) {
            errorMsg.getErrors().add(ve.getMessage());
        }
    }
    
    static {
        pattern = Pattern.compile("http(s)?://([\\w-]+\\.)+[\\w-]+(/[\\w- ./?%&=]*)?");
    }
}
