package xgs.net.commons;

import com.jfinal.kit.PathKit;
import com.jfinal.kit.Prop;
import com.jfinal.kit.PropKit;
import com.jfinal.plugin.activerecord.dialect.MysqlDialect;
import com.jfinal.plugin.activerecord.generator.BaseModelGenerator;
import com.jfinal.plugin.activerecord.generator.DataDictionaryGenerator;
import com.jfinal.plugin.activerecord.generator.Generator;
import com.jfinal.plugin.druid.DruidPlugin;
import xgs.net.generator.MdDataDictionaryGenerator;
import xgs.net.generator.XgsModelGenerator;

import javax.sql.DataSource;

public class GeneratorBean
{
    public static DataSource getDataSource() {
        final Prop p = PropKit.use("jdbc.properties");
        final DruidPlugin druidPlugin = new DruidPlugin(p.get("jdbc.mysql.uri"), p.get("jdbc.mysql.user"), p.get("jdbc.mysql.password"));
        druidPlugin.setConnectionProperties("useInformationSchema=true;remarks=true");
        druidPlugin.start();
        return druidPlugin.getDataSource();
    }
    
    public static void main(final String[] args) {
        final String baseModelPackageName = "xgs.net.model.base";
        final String baseModelOutputDir = PathKit.getWebRootPath() + "../../entity/src/main/java/xgs/net/model/base";
        final String modelPackageName = "xgs.net.model";
        final String modelOutputDir = baseModelOutputDir + "/..";
        final DataSource dataSource = getDataSource();
        final XgsModelGenerator modelGenerator = new XgsModelGenerator(modelPackageName, baseModelPackageName, modelOutputDir);
        final BaseModelGenerator baseModelGenerator = new BaseModelGenerator(baseModelPackageName, baseModelOutputDir);
        final Generator generator = new Generator(dataSource, baseModelGenerator, modelGenerator);
        generator.setDialect(new MysqlDialect());
        generator.addExcludedTable("adv");
        generator.setGenerateDaoInModel(true);
        final DataDictionaryGenerator dg = new MdDataDictionaryGenerator(dataSource, modelOutputDir);
        dg.setDataDictionaryFileName("\u6570\u636e\u5b57\u5178.md");
        generator.setDataDictionaryGenerator(dg);
        generator.setGenerateDataDictionary(true);
        generator.generate();
    }
}
