package xgs.net.handle;

import com.jfinal.handler.Handler;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class RenderingTimeHandler extends Handler
{
    protected final Logger log  = LoggerFactory.getLogger(this.getClass());

    
    public void handle(final String target, final HttpServletRequest request, final HttpServletResponse response, final boolean[] isHandled) {
        final long start = System.currentTimeMillis();
        final String userAgent = request.getHeader("User-Agent");
        this.next.handle(target, request, response, isHandled);
        final long end = System.currentTimeMillis();
        this.log.info("User-Agent:[" + userAgent + "]\tURL:[" + target + "]\tTRENDING TIME:\t[" + (end - start) + "]ms");
    }
}
