package xgs.net.init;

import com.alibaba.druid.filter.logging.Slf4jLogFilter;
import com.alibaba.druid.filter.stat.StatFilter;
import com.alibaba.druid.wall.WallFilter;
import com.jfinal.plugin.activerecord.dialect.Dialect;
import com.jfinal.plugin.activerecord.dialect.MysqlDialect;
import com.jfinal.plugin.druid.DruidPlugin;

public class MysqlDb implements InitDb
{
    @Override
    public DruidPlugin init() {
        final DruidPlugin druidPlugin = new DruidPlugin(MysqlDb.prop.get("jdbc.mysql.url"), MysqlDb.prop.get("jdbc.mysql.user"), MysqlDb.prop.get("jdbc.mysql.password"));
        druidPlugin.setValidationQuery(MysqlDb.prop.get("jdbc.mysql.validation_query"));
        druidPlugin.addFilter(new StatFilter());
        final WallFilter wall = new WallFilter();
        wall.setDbType("mysql");
        druidPlugin.addFilter(wall);
        druidPlugin.addFilter(new Slf4jLogFilter());
        return druidPlugin;
    }
    
    @Override
    public Dialect getDialect() {
        return new MysqlDialect();
    }
}
