package xgs.net.init;

import com.alibaba.druid.filter.logging.Slf4jLogFilter;
import com.alibaba.druid.filter.stat.StatFilter;
import com.alibaba.druid.wall.WallFilter;
import com.jfinal.plugin.activerecord.dialect.Dialect;
import com.jfinal.plugin.activerecord.dialect.PostgreSqlDialect;
import com.jfinal.plugin.druid.DruidPlugin;

public class PostgresDb implements InitDb
{
    @Override
    public DruidPlugin init() {
        final DruidPlugin druidPlugin = new DruidPlugin(PostgresDb.prop.get("jdbc.postgres.uri"), PostgresDb.prop.get("jdbc.postgres.user"), PostgresDb.prop.get("jdbc.postgres.password"));
        druidPlugin.setValidationQuery(PostgresDb.prop.get("jdbc.postgres.validation_query"));
        druidPlugin.addFilter(new StatFilter());
        final WallFilter wall = new WallFilter();
        wall.setDbType("postgresql");
        druidPlugin.addFilter(wall);
        druidPlugin.addFilter(new Slf4jLogFilter());
        return druidPlugin;
    }
    
    @Override
    public Dialect getDialect() {
        return new PostgreSqlDialect();
    }
}
