package xgs.net.interceptors;

import com.jfinal.aop.Interceptor;
import com.jfinal.aop.Invocation;
import com.jfinal.core.Controller;
import xgs.net.entity.Msg;

public class DomainInterceptor implements Interceptor
{
    public void intercept(final Invocation inv) {
        Controller controller = inv.getTarget();
        controller.getResponse().addHeader("Access-Control-Allow-Headers", "X-Requested-With,X_Requested_With,Content-Type,Access-Token,x-token,x-location");
        controller.getResponse().addHeader("Access-Control-Allow-Origin", "*");
        controller.getResponse().addHeader("Access-Control-Allow-Credentials", "true");
        controller.getResponse().addHeader("Access-Control-Allow-Methods", "*");
        controller.getResponse().addHeader("Access-Control-Expose-Headers", "*");
        if (controller.getRequest().getMethod().equalsIgnoreCase("OPTIONS")) {
            controller.renderJson(new Msg());
            return;
        }
        inv.invoke();
    }
}
