package xgs.net.interceptors;

import com.jfinal.aop.Interceptor;
import com.jfinal.aop.Invocation;
import com.jfinal.core.Controller;
import xgs.net.entity.Msg;
import xgs.net.exception.XgsException;

public class JsonInterceptor implements Interceptor
{
    public void intercept(Invocation inv) {
        try {
            inv.invoke();
        }
        catch (Exception e) {
            final Controller controller = inv.getController();
            e.printStackTrace();
            final Msg msg = new Msg();
            if (e instanceof XgsException) {
                int code = ((XgsException)e).getCode();
                msg.setCode(code);
                msg.setMsg(e.getMessage());
            }
            else {
                msg.setCode(500);
                msg.setMsg("\u7cfb\u7edf\u9519\u8bef");
            }
            controller.renderJson(msg);
        }
    }
}
