package xgs.net.interceptors;

import com.jfinal.aop.Interceptor;
import com.jfinal.aop.Invocation;
import xgs.net.annotation.Method;
import xgs.net.entity.Msg;

public class RestFulInterceptor implements Interceptor
{
    public void intercept(Invocation inv) {
        Method method = inv.getMethod().getAnnotation(Method.class);
        if (method == null) {
            inv.invoke();
            return;
        }
        String reqMethod = inv.getController().getRequest().getMethod().toUpperCase();
        if (!reqMethod.equals(method.value().name())) {
            Msg msg = new Msg();
            msg.setCode(405);
            msg.setMsg("only allow " + method.value());
            inv.getController().renderJson(msg);
            return;
        }
        inv.invoke();
    }
}
