package xgs.net.logs;

import com.jfinal.log.Log;

import java.io.PrintStream;
import java.util.Locale;

public class LogPrintStream extends PrintStream
{
    private final Log log;
    private final boolean error;
    
    public LogPrintStream(boolean error) {
        super(error ? System.err : System.out);
        this.log = Log.getLog("System.out:");
        this.error = error;
    }
    
    @Override
    public void print(String s) {
        if (this.error) {
            this.log.error(s);
        }
        else {
            this.log.info(s);
        }
    }
    
    @Override
    public void println() {
    }
    
    @Override
    public void println(String x) {
        if (this.error) {
            this.log.error(x);
        }
        else {
            this.log.info(x);
        }
    }
    
    @Override
    public PrintStream printf(String format, Object... args) {
        if (this.error) {
            this.log.error(String.format(format, args));
        }
        else {
            this.log.info(String.format(format, args));
        }
        return this;
    }
    
    @Override
    public PrintStream printf(Locale l, String format, Object... args) {
        if (this.error) {
            this.log.error(String.format(l, format, args));
        }
        else {
            this.log.info(String.format(l, format, args));
        }
        return this;
    }
}
