package xgs.net.plugin.tips.ruanwei.tool;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;

public class SmsClientAccessTool
{
    private static SmsClientAccessTool smsClientToolInstance;
    
    public static synchronized SmsClientAccessTool getInstance() {
        if (SmsClientAccessTool.smsClientToolInstance == null) {
            SmsClientAccessTool.smsClientToolInstance = new SmsClientAccessTool();
        }
        return SmsClientAccessTool.smsClientToolInstance;
    }
    
    public String doAccessHTTPPost(final String sendUrl, final String sendParam, String backEncodType) {
        final StringBuffer receive = new StringBuffer();
        BufferedWriter wr = null;
        try {
            if (backEncodType == null || backEncodType.equals("")) {
                backEncodType = "UTF-8";
            }
            final URL url = new URL(sendUrl);
            final HttpURLConnection URLConn = (HttpURLConnection)url.openConnection();
            URLConn.setDoOutput(true);
            URLConn.setDoInput(true);
            URLConn.setRequestMethod("POST");
            URLConn.setUseCaches(false);
            URLConn.setAllowUserInteraction(true);
            HttpURLConnection.setFollowRedirects(true);
            URLConn.setInstanceFollowRedirects(true);
            URLConn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
            URLConn.setRequestProperty("Content-Length", String.valueOf(sendParam.getBytes().length));
            final DataOutputStream dos = new DataOutputStream(URLConn.getOutputStream());
            dos.writeBytes(sendParam);
            final BufferedReader rd = new BufferedReader(new InputStreamReader(URLConn.getInputStream(), backEncodType));
            String line;
            while ((line = rd.readLine()) != null) {
                receive.append(line).append("\r\n");
            }
            rd.close();
        }
        catch (IOException e) {
            receive.append("\u8bbf\u95ee\u4ea7\u751f\u4e86\u5f02\u5e38-->").append(e.getMessage());
            e.printStackTrace();
        }
        finally {
            if (wr != null) {
                try {
                    wr.close();
                }
                catch (IOException ex) {
                    ex.printStackTrace();
                }
                wr = null;
            }
        }
        return receive.toString();
    }
    
    public String doAccessHTTPGet(final String sendUrl, String backEncodType) {
        final StringBuffer receive = new StringBuffer();
        BufferedReader in = null;
        try {
            if (backEncodType == null || backEncodType.equals("")) {
                backEncodType = "UTF-8";
            }
            final URL url = new URL(sendUrl);
            final HttpURLConnection URLConn = (HttpURLConnection)url.openConnection();
            URLConn.setDoInput(true);
            URLConn.setDoOutput(true);
            URLConn.connect();
            URLConn.getOutputStream().flush();
            in = new BufferedReader(new InputStreamReader(URLConn.getInputStream(), backEncodType));
            String line;
            while ((line = in.readLine()) != null) {
                receive.append(line).append("\r\n");
            }
        }
        catch (IOException e) {
            receive.append("\u8bbf\u95ee\u4ea7\u751f\u4e86\u5f02\u5e38-->").append(e.getMessage());
            e.printStackTrace();
        }
        finally {
            if (in != null) {
                try {
                    in.close();
                }
                catch (IOException ex) {
                    ex.printStackTrace();
                }
                in = null;
            }
        }
        return receive.toString();
    }
}
