package xgs.net.service;

import com.jfinal.plugin.activerecord.Page;
import xgs.net.annotation.Service;
import xgs.net.entity.PageEntity;
import xgs.net.exception.XgsException;
import xgs.net.model.TbInfoList;
import xgs.net.utils.IdGen;

@Service
public class InfoListService extends BaseService<TbInfoList> {

    private static final String findList = " SELECT * ";
    private static final String findListExcept = " FROM tb_info_list WHERE type = ? ";

    public void save(String name,String collega,String type,String postion,String phone,
                     Integer isParty,String work,Long sendDate){
        try {
            TbInfoList infoList = new TbInfoList();
            infoList.setId(IdGen.getId());
            infoList.setName(name);
            infoList.setCollege(collega);
            infoList.setType(type);
            infoList.setPhone(phone);
            infoList.setIsParty(isParty);
            infoList.setPosition(postion);
            infoList.setWorkUnit(work);
            infoList.setSendDate(sendDate);
            infoList.setCreated(System.currentTimeMillis());
            infoList.save();
        }catch (Exception e){
            if(e.getMessage() != null && e.getMessage().contains("phone_unique")){
                throw new XgsException(20021,"您已经报过名");
            }
        }

    }

    public Page<TbInfoList> page(PageEntity pageEntity,String type){
        return this.dao.paginate(pageEntity.getPageNo(),pageEntity.getPageSize(),findList,findListExcept,type);
    }
}
