package xgs.net.session;

import com.jfinal.plugin.redis.Cache;
import com.jfinal.plugin.redis.Redis;

public class RedisSessionManager implements SessionManager
{
    private final String SESSION_PREFIX = "xgs.net.session:";
    private final Cache cache;
    
    public RedisSessionManager() {
        this.cache = Redis.use();
    }
    
    public RedisSessionManager(final String cacheName) {
        this.cache = Redis.use(cacheName);
    }
    
    public RedisSessionManager(final Cache cache) {
        this.cache = cache;
    }
    
    @Override
    public Session get(final String sessionId) {
        return (Session)this.cache.get("xgs.net.session:".concat(sessionId));
    }

    @Override
    public void save(final Session session) {
        final String sessionId = session.getId();
        final int seconds = 100000;
        this.cache.setex("xgs.net.session:".concat(sessionId), seconds, session);
    }

    @Override
    public void update(final Session session) {
        this.save(session);
    }
}
