package xgs.net.utils;

import com.alibaba.fastjson.serializer.JSONSerializer;
import com.alibaba.fastjson.serializer.ObjectSerializer;
import com.alibaba.fastjson.serializer.SerializeWriter;

import java.io.IOException;
import java.lang.reflect.Type;

public class LongToStringSerializer implements ObjectSerializer
{
    public static final LongToStringSerializer instance;
    
    public void write(JSONSerializer jsonSerializer, Object object, Object fieldName, Type type, int i) throws IOException {
        SerializeWriter out = jsonSerializer.getWriter();
        if (object == null) {
            out.writeNull();
            return;
        }
        if (object instanceof Long) {
            String strVal = object.toString();
            out.writeString(strVal);
            return;
        }
        JSONSerializer.write(out, object);
    }
    
    static {
        instance = new LongToStringSerializer();
    }
}
