package genrator;

import com.jfinal.kit.PathKit;
import com.jfinal.kit.Prop;
import com.jfinal.kit.PropKit;
import com.jfinal.plugin.activerecord.dialect.MysqlDialect;
import com.jfinal.plugin.activerecord.generator.BaseModelGenerator;
import com.jfinal.plugin.activerecord.generator.DataDictionaryGenerator;
import com.jfinal.plugin.activerecord.generator.Generator;
import com.jfinal.plugin.druid.DruidPlugin;
import xgs.net.generator.MdDataDictionaryGenerator;
import xgs.net.generator.XgsModelGenerator;

import javax.sql.DataSource;

public class GeneratorBean
{
    public static DataSource getDataSource() {
        Prop p = PropKit.use("jdbc.properties");
        DruidPlugin druidPlugin = new DruidPlugin(p.get("jdbc.mysql.url"), p.get("jdbc.mysql.user"), p.get("jdbc.mysql.password"));
        druidPlugin.setConnectionProperties("useInformationSchema=true;remarks=true");
        druidPlugin.start();
        return druidPlugin.getDataSource();
    }
    
    public static void main(final String[] args) {
        //baseModel包名
        String baseModelPackageName = "xgs.net.model.base";
        //baseModel生成路劲
        String baseModelOutputDir = PathKit.getWebRootPath() + "/src/main/java/xgs/net/model/base";
        //model包名
        String modelPackageName = "xgs.net.model";
        //model生成路劲
        String modelOutputDir = baseModelOutputDir + "/..";
        //获取数据源
        DataSource dataSource = getDataSource();

        XgsModelGenerator modelGenerator = new XgsModelGenerator(modelPackageName, baseModelPackageName, modelOutputDir);
        BaseModelGenerator baseModelGenerator = new BaseModelGenerator(baseModelPackageName, baseModelOutputDir);
        Generator generator = new Generator(dataSource, baseModelGenerator, modelGenerator);
        //设置数据库方言
        generator.setDialect(new MysqlDialect());
        generator.addExcludedTable("adv");
        generator.setGenerateDaoInModel(true);
        DataDictionaryGenerator dg = new MdDataDictionaryGenerator(dataSource, modelOutputDir);
        dg.setDataDictionaryFileName("\u6570\u636e\u5b57\u5178.md");
        generator.setDataDictionaryGenerator(dg);
        generator.setGenerateDataDictionary(true);
        generator.generate();
    }
}
