package xgs.net.common;

import com.jfinal.kit.PathKit;
import com.jfinal.kit.Prop;
import com.jfinal.kit.PropKit;
import com.jfinal.plugin.activerecord.dialect.MysqlDialect;
import com.jfinal.plugin.activerecord.generator.BaseModelGenerator;
import com.jfinal.plugin.activerecord.generator.DataDictionaryGenerator;
import com.jfinal.plugin.activerecord.generator.Generator;
import com.jfinal.plugin.druid.DruidPlugin;
import xgs.net.generator.MdDataDictionaryGenerator;
import xgs.net.generator.XgsModelGenerator;

import javax.sql.DataSource;

public class GeneratorBean {
    public static DataSource getDataSource() {
        Prop p = PropKit.use("jdbc.properties");
        DruidPlugin druidPlugin = new DruidPlugin(p.get("jdbc.mysql.uri"), p.get("jdbc.mysql.user"), p.get("jdbc.mysql.password"));
        druidPlugin.setConnectionProperties("useInformationSchema=true;remarks=true");
        druidPlugin.start();
        return druidPlugin.getDataSource();
    }

    public static void main(String[] args) {
        String baseModelPackageName = "xgs.net.model.base";

        String baseModelOutputDir = PathKit.getWebRootPath() + "/../image/src/main/java/xgs/net/model/base";


        String modelPackageName = "xgs.net.model";

        String modelOutputDir = baseModelOutputDir + "/..";

        DataSource dataSource = getDataSource();


        XgsModelGenerator modelGenerator = new XgsModelGenerator(modelPackageName, baseModelPackageName, modelOutputDir);
        BaseModelGenerator baseModelGenerator = new BaseModelGenerator(baseModelPackageName, baseModelOutputDir);
        Generator generator = new Generator(dataSource, baseModelGenerator, modelGenerator);


        generator.setDialect(new MysqlDialect());

        generator.addExcludedTable(new String[]{"adv"});

        generator.setGenerateDaoInModel(true);

        DataDictionaryGenerator dg = new MdDataDictionaryGenerator(dataSource, modelOutputDir);
        dg.setDataDictionaryFileName("数据字典.md");
        generator.setDataDictionaryGenerator(dg);
        generator.setGenerateDataDictionary(true);


        generator.generate();
    }
}
