package xgs.net.common;

import com.jfinal.aop.Interceptor;
import com.jfinal.config.Constants;
import com.jfinal.config.Handlers;
import com.jfinal.config.Interceptors;
import com.jfinal.config.Plugins;
import xgs.net.handle.Uri404Handle;
import xgs.net.init.XgsConfig;
import xgs.net.interceptors.DomainInterceptor;
import xgs.net.interceptors.JsonInterceptor;
import xgs.net.plugin.IocPlugin;
import xgs.net.utils.MyJsonFactory;

public class UploadConfig extends XgsConfig
{
  public void constant(Constants me)
  {
    me.setJsonFactory(new MyJsonFactory());
  }
  
  public void plugin(Plugins me)
  {
    String[] pkgs = { "xgs.net" };
    IocPlugin ioc = new IocPlugin(pkgs, new Interceptor[0]);
    me.add(ioc);
    this.routes.add(ioc.getRoutes());
  }
  
  public void interceptor(Interceptors me)
  {
    me.addGlobalActionInterceptor(new DomainInterceptor());
    me.addGlobalActionInterceptor(new JsonInterceptor());
  }
  
  public void handler(Handlers me)
  {
    me.add(new Uri404Handle());
  }
}
