package xgs.net.generator;

import com.jfinal.kit.StrKit;
import com.jfinal.plugin.activerecord.generator.ColumnMeta;
import com.jfinal.plugin.activerecord.generator.DataDictionaryGenerator;
import com.jfinal.plugin.activerecord.generator.TableMeta;

import javax.sql.DataSource;

public class MdDataDictionaryGenerator extends DataDictionaryGenerator
{
    public MdDataDictionaryGenerator(final DataSource dataSource, final String dataDictionaryOutputDir) {
        super(dataSource, dataDictionaryOutputDir);
    }
    
    protected String genSeparateLine(final TableMeta tm) {
        return "";
    }
    
    protected void generateTable(final TableMeta tableMeta, final StringBuilder ret) {
        ret.append("Table: ").append(tableMeta.name);
        if (StrKit.notBlank(tableMeta.remarks)) {
            ret.append("\uff08").append(this.clearBlank(tableMeta.remarks)).append("\uff09");
        }
        ret.append("\n");
        final String sparateLine = this.genSeparateLine(tableMeta);
        ret.append(sparateLine);
        this.genTableHead(tableMeta, ret);
        ret.append(sparateLine);
        for (final ColumnMeta columnMeta : tableMeta.columnMetas) {
            this.genColumn(tableMeta, columnMeta, ret);
        }
        ret.append(sparateLine);
        ret.append("\n");
    }
    
    protected void genTableHead(final TableMeta tm, final StringBuilder ret) {
        ret.append('\n').append('|');
        this.genCell(tm.colNameMaxLen, " ", "Field", " ", "|", ret);
        this.genCell(tm.colTypeMaxLen, " ", "Type", " ", "|", ret);
        this.genCell("Null".length(), " ", "Null", " ", "|", ret);
        this.genCell("Key".length(), " ", "Key", " ", "|", ret);
        this.genCell(tm.colDefaultValueMaxLen, " ", "Default", " ", "|", ret);
        this.genCell("Remarks".length(), " ", "Remarks", " ", "|", ret);
        ret.append('\n').append('|');
        this.genCell(tm.colNameMaxLen, " ", "-", "-", "|", ret);
        ret.replace(ret.length() - 2, ret.length() - 1, " ");
        this.genCell(tm.colTypeMaxLen, " ", "-", "-", "|", ret);
        ret.replace(ret.length() - 2, ret.length() - 1, " ");
        this.genCell("Null".length(), " ", "-", "-", "|", ret);
        ret.replace(ret.length() - 2, ret.length() - 1, " ");
        this.genCell("Key".length(), " ", "-", "-", "|", ret);
        ret.replace(ret.length() - 2, ret.length() - 1, " ");
        this.genCell(tm.colDefaultValueMaxLen, " ", "-", "-", "|", ret);
        ret.replace(ret.length() - 2, ret.length() - 1, " ");
        this.genCell("Remarks".length(), " ", "-", "-", "|", ret);
        ret.replace(ret.length() - 2, ret.length() - 1, " ");
        ret.append('\n');
    }
    
    protected void genColumn(final TableMeta tableMeta, final ColumnMeta columnMeta, final StringBuilder ret) {
        ret.append('|');
        this.genCell(tableMeta.colNameMaxLen, " ", columnMeta.name, " ", "|", ret);
        this.genCell(tableMeta.colTypeMaxLen, " ", columnMeta.type, " ", "|", ret);
        this.genCell("Null".length(), " ", columnMeta.isNullable, " ", "|", ret);
        this.genCell("Key".length(), " ", columnMeta.isPrimaryKey, " ", "|", ret);
        this.genCell(tableMeta.colDefaultValueMaxLen, " ", columnMeta.defaultValue, " ", "|", ret);
        this.genCell("Remarks".length(), " ", this.clearBlank(columnMeta.remarks), " ", "|", ret);
        ret.append("\n");
    }
    
    private String clearBlank(final String str) {
        return str.replaceAll("[ |\t|\n]+", "");
    }
}
