package xgs.net.plugin;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.jfinal.core.Controller;
import com.jfinal.core.Injector;
import com.jfinal.plugin.activerecord.Model;
import xgs.net.annotation.Ctl;
import xgs.net.annotation.ParamInfo;
import xgs.net.entity.*;
import xgs.net.exception.XgsException;
//import xgs.net.model.SysFunc;
import xgs.net.query.Filter;
import xgs.net.query.FilterBuilder;
import xgs.net.query.util.LigerFilter;
import xgs.net.util.Operation;

import javax.servlet.http.HttpServletRequest;
import java.lang.annotation.Annotation;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;

public class MvcBeans
{
    private static Map<String, CtlEntity> beans;
    private static final String where = "where";
    
    static void setCtl(final Ctl ctl, final CtlEntity ce) {
        if (MvcBeans.beans.containsKey(ctl.value())) {
            throw new RuntimeException("multi value : " + ctl.value());
        }
        MvcBeans.beans.put(ctl.value(), ce);
    }
    
//    public static Object run(final SysFunc func, final Controller controller) throws Throwable {
//        if (!MvcBeans.beans.containsKey(func.getCtl())) {
//            throw new XgsException(404);
//        }
//        final CtlEntity ce = MvcBeans.beans.get(func.getCtl());
//        if (!ce.getActs().containsKey(func.getAct())) {
//            throw new XgsException(404);
//        }
//        final ActEntity ae = ce.getActs().get(func.getAct());
//        final List<ParamEntity> paramEntityList = ae.getParameters();
//        final List<Class<?>> parameterTypes = Lists.newLinkedList();
//        final List<Object> parameters = Lists.newLinkedList();
//        for (final ParamEntity pe : paramEntityList) {
//            parameterTypes.add(pe.getType());
//            final Annotation antt = pe.getAnnotation();
//            if (antt instanceof ParamInfo) {
//                pe.getType().getName();
//                parameters.add(getValue(pe.getType().getName(), antt, controller));
//            }
//            else if (pe.getType().isAssignableFrom(HttpServletRequest.class)) {
//                parameters.add(controller.getRequest());
//            }
//            else if (pe.getType().isAssignableFrom(Controller.class)) {
//                parameters.add(controller);
//            }
//            else if (pe.getType().isAssignableFrom(FilterBuilder.class)) {
//                parameters.add(getFilter(controller.getRequest()));
//            }
//            else if (pe.getType().isAssignableFrom(OperaterEntity.class)) {
//                parameters.add(Operation.setOperaterUtils(controller.getRequest()));
//            }
//            else if (pe.getType().isAssignableFrom(PageEntity.class)) {
//                parameters.add(setPage(controller));
//            }
//            else {
//                Model model = getModel(pe.getType(), controller);
//                Operation.setModelOperate(model, controller.getRequest());
//                parameters.add(model);
//            }
//        }
//        try {
//            return ae.getMethod().invoke(ce.getObj(), parameters.stream().toArray());
//        }
//        catch (IllegalAccessException e) {
//            throw e;
//        }
//        catch (IllegalArgumentException e2) {
//            throw e2;
//        }
//        catch (InvocationTargetException e3) {
//            throw e3.getTargetException();
//        }
//    }
//
    protected static final FilterBuilder getFilter(final HttpServletRequest request) {
        final Filter filter = LigerFilter.getInstance();
        return filter.parse(request.getParameter("where"));
    }
    
    private static Object getValue(final String className, final Annotation antt, final Controller controller) throws Exception {
        final String value = controller.getPara(((ParamInfo)antt).value());
        if ("java.lang.Integer".equals(className) || "int".equals(className)) {
            return Integer.valueOf(value);
        }
        if ("java.lang.Long".equals(className) || "long".equals(className)) {
            return Long.valueOf(value);
        }
        if ("java.lang.Double".equals(className) || "double".equals(className)) {
            return Double.valueOf(value);
        }
        if ("java.lang.Float".equals(className) || "float".equals(className)) {
            return Float.valueOf(value);
        }
        if ("java.lang.Boolean".equals(className) || "boolean".equals(className)) {
            return Boolean.valueOf(value);
        }
        if ("java.lang.String".equals(className) || "String".equals(className)) {
            return value;
        }
        throw new Exception("\u53c2\u6570\u9519\u8bef");
    }
    
    public static <T> Model getModel(final Class<T> modelClass, final Controller controller) {
        return (Model) Injector.injectModel((Class)modelClass, null, controller.getRequest(), true);
    }
    
    private static PageEntity setPage(final Controller controller) {
        final PageEntity entity = new PageEntity();
        entity.setPageNo(controller.getParaToInt("pageNo", 1));
        entity.setPageSize(controller.getParaToInt("pageSize", 10));
        return entity;
    }
    
    static {
        MvcBeans.beans = Maps.newConcurrentMap();
    }
}
