package xgs.net.util;

import com.jfinal.plugin.activerecord.Model;
import com.jfinal.plugin.activerecord.Table;
import com.jfinal.plugin.activerecord.TableMapping;
import xgs.net.entity.OperaterEntity;
import xgs.net.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;

public class Operation
{
    public static final String operateTime = "operate_time";
    public static final String operatorId = "operator_id";
    public static final String operator = "operator";
    public static final String operateIp = "operate_ip";
    
    public static void setModelOperate(final Model model, final HttpServletRequest request) {
        final Table table = _getTable(model);
        if (table.hasColumnLabel("operate_time")) {
            model.set("operate_time", (Object)System.currentTimeMillis());
        }
        if (table.hasColumnLabel("operator_id")) {
            model.set("operator_id", (Object)1L);
        }
        if (table.hasColumnLabel("operator")) {
            model.set("operator", (Object)"1");
        }
        if (table.hasColumnLabel("operate_ip")) {
            model.set("operate_ip", (Object)WebUtils.getIP(request));
        }
    }
    
    public static OperaterEntity setOperaterUtils(final HttpServletRequest request) {
        final OperaterEntity operaterEntity = new OperaterEntity();
        operaterEntity.setOperateTime(System.currentTimeMillis());
        operaterEntity.setOperateIp(WebUtils.getIP(request));
        operaterEntity.setOperator("1");
        operaterEntity.setOperatorId(1L);
        return operaterEntity;
    }
    
    protected static Table _getTable(final Model model) {
        return TableMapping.me().getTable((Class)model.getClass());
    }
}
