package xgs.net.searcher;

import org.objectweb.asm.AnnotationVisitor;
import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;

import java.io.IOException;
import java.io.InputStream;
import java.lang.annotation.Annotation;
import java.util.HashMap;
import java.util.Map;

public class AnnotationReader
{
    private Map<String, Class<? extends Annotation>> annotationMap;
    
    public AnnotationReader() {
        this.annotationMap = new HashMap<String, Class<? extends Annotation>>();
    }
    
    public void addAnnotation(final Class<? extends Annotation> annotation) {
        this.annotationMap.put('L' + annotation.getName().replace('.', '/') + ';', annotation);
    }
    
    public boolean isAnnotationed(final InputStream inputStream) {
        ClassReader classReader;
        try {
            classReader = new ClassReader(inputStream);
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }
        final boolean[] visitorResult = { false };
        classReader.accept((ClassVisitor)new ClassVisitor(327680) {
            public AnnotationVisitor visitAnnotation(final String annotation, final boolean visible) {
                if (AnnotationReader.this.annotationMap.containsKey(annotation)) {
                    visitorResult[0] = true;
                }
                return super.visitAnnotation(annotation, visible);
            }
        }, 1);
        return visitorResult[0];
    }
}
