package xgs.net.searcher;

import xgs.net.utils.Matcher;

import java.util.LinkedHashSet;
import java.util.Set;

public class ResourceMatcherSearcher
{
    public static Set<String> getFiles(final String[] packageNames, final String pattern) {
        final String[] patterns = { pattern };
        return getFiles(packageNames, patterns);
    }
    
    public static Set<String> getFiles(final String[] packageNames, final String[] patterns) {
        final Set<String> fileSet = new LinkedHashSet<String>();
        final FileSearcher finder = new FileSearcher() {
            public void visitFileEntry(final FileEntry file) {
                if (isMatch(file, patterns)) {
                    final String fileName = file.getQualifiedFileName();
                    fileSet.add(fileName);
                }
            }
        };
        finder.lookupClasspath(packageNames);
        return fileSet;
    }
    
    private static boolean isMatch(final FileSearcher.FileEntry file, final String[] patterns) {
        return !file.isDirectory() && Matcher.matchName(file.getName(), patterns);
    }
}
