package xgs.net.token;

import xgs.net.utils.Base64Utils;
import xgs.net.utils.ByteUtils;
import xgs.net.utils.IdGen;
import xgs.net.utils.StrUtils;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class JwtToken
{
    private static final String key = "adwfsadflkasdfjkdskjflksa";
    private static final String op = ".";
    
    public static void main(final String[] args) {
        final Long start = System.currentTimeMillis();
        final Long id = IdGen.getId();
        final String ccc = createToken(1L);
        System.out.println(ccc);
        final boolean c = verify(ccc);
        System.out.println(c);
        final Long end = System.currentTimeMillis();
        System.out.println(end - start);
    }
    
    public static String createToken(final Long id) {
        return id + "." + encode(id);
    }
    
    private static String encode(final Long id) {
        String encodeStr = "";
        try {
            final MessageDigest messageDigest = MessageDigest.getInstance("SHA-256");
            final byte[] bytes = key.getBytes();
            final byte[] idbytes = ByteUtils.longToByte(id);
            final byte[] dist = new byte[bytes.length + idbytes.length];
            System.arraycopy(bytes, 0, dist, 0, bytes.length);
            System.arraycopy(idbytes, 0, dist, bytes.length, idbytes.length);
            messageDigest.update(dist);
            encodeStr = byte2Hex(messageDigest.digest());
            System.out.println(encodeStr);
            encodeStr = Base64Utils.encode(encodeStr).replaceAll("[\\s*\t\n\r=]", "");
        }
        catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
        return encodeStr;
    }
    
    public static boolean verify(final String token) {
        if (StrUtils.isBlank(token)) {
            return false;
        }
        try {
            final String[] strs = token.split("\\.");
            final Long id = Long.parseLong(strs[0]);
            System.out.println(strs[1]);
            System.out.println(encode(id));
            return strs[1].equals(encode(id));
        }
        catch (Exception e) {
            return false;
        }
    }
    
    private static String byte2Hex(final byte[] bytes) {
        final StringBuffer stringBuffer = new StringBuffer();
        String temp = null;
        for (int i = 0; i < bytes.length; ++i) {
            temp = Integer.toHexString(bytes[i] & 0xFF);
            if (temp.length() == 1) {
                stringBuffer.append("0");
            }
            stringBuffer.append(temp);
        }
        return stringBuffer.toString();
    }
}
