package xgs.net.utils;

import javax.xml.bind.DatatypeConverter;
import java.nio.charset.Charset;

public class Base64Utils
{
    public static String encode(final byte[] value) {
        return DatatypeConverter.printBase64Binary(value);
    }
    
    public static String encode(final String value) {
        final byte[] val = value.getBytes(Charsets.UTF_8);
        return encode(val);
    }
    
    public static String encode(final String value, final String charsetName) {
        final byte[] val = value.getBytes(Charset.forName(charsetName));
        return encode(val);
    }
    
    public static byte[] decodeBase64(final String value) {
        return DatatypeConverter.parseBase64Binary(value);
    }
    
    public static String decode(final String value) {
        final byte[] decodedValue = decodeBase64(value);
        return new String(decodedValue, Charsets.UTF_8);
    }
    
    public static String decode(final String value, final String charsetName) {
        final byte[] decodedValue = decodeBase64(value);
        return new String(decodedValue, Charset.forName(charsetName));
    }
}
