package xgs.net.utils;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

public class ByteUtils
{
    public static final byte[] is2byte(final InputStream inStream) throws IOException {
        final ByteArrayOutputStream swapStream = new ByteArrayOutputStream();
        final byte[] buff = new byte[100];
        int rc = 0;
        while ((rc = inStream.read(buff, 0, 100)) > 0) {
            swapStream.write(buff, 0, rc);
        }
        final byte[] in2b = swapStream.toByteArray();
        return in2b;
    }
    
    public static byte[] longToByte(final long number) {
        byte[] buffer = new byte[8];
        for (int i = 0; i < 8; i++) {
            int offset = 64 - (i + 1) * 8;
            buffer[i] = (byte) ((number >> offset) & 0xff);
        }
        return buffer;
    }
    
    public static long byteToLong(final byte[] b) {
        long s = 0L;
        final long s2 = b[0] & 0xFF;
        long s3 = b[1] & 0xFF;
        long s4 = b[2] & 0xFF;
        long s5 = b[3] & 0xFF;
        long s6 = b[4] & 0xFF;
        long s7 = b[5] & 0xFF;
        long s8 = b[6] & 0xFF;
        long s9 = b[7] & 0xFF;
        s3 <<= 8;
        s4 <<= 16;
        s5 <<= 24;
        s6 <<= 32;
        s7 <<= 40;
        s8 <<= 48;
        s9 <<= 56;
        s = (s2 | s3 | s4 | s5 | s6 | s7 | s8 | s9);
        return s;
    }
    
    public static byte[] intToByte(final int number) {
        int temp = number;
        final byte[] b = new byte[4];
        for (int i = 0; i < b.length; ++i) {
            b[i] = (byte)(Object)new Integer(temp & 0xFF);
            temp >>= 8;
        }
        return b;
    }
    
    public static int byteToInt(final byte[] b) {
        int s = 0;
        final int s2 = b[0] & 0xFF;
        int s3 = b[1] & 0xFF;
        int s4 = b[2] & 0xFF;
        int s5 = b[3] & 0xFF;
        s5 <<= 24;
        s4 <<= 16;
        s3 <<= 8;
        s = (s2 | s3 | s4 | s5);
        return s;
    }
    
    public static byte[] shortToByte(final short number) {
        int temp = number;
        final byte[] b = new byte[2];
        for (int i = 0; i < b.length; ++i) {
            b[i] = (byte)(Object)new Integer(temp & 0xFF);
            temp >>= 8;
        }
        return b;
    }
    
    public static short byteToShort(final byte[] b) {
        short s = 0;
        final short s2 = (short)(b[0] & 0xFF);
        short s3 = (short)(b[1] & 0xFF);
        s3 <<= 8;
        s = (short)(s2 | s3);
        return s;
    }
}
