package xgs.net.utils;

import javax.net.ssl.HttpsURLConnection;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.*;

public class HttpUtil
{
    public static String buildRequestPara(final Map<String, Object> params) throws UnsupportedEncodingException {
        final List<String> keys = new ArrayList<String>(params.keySet());
        Collections.sort(keys);
        String prestr = "";
        for (int i = 0; i < keys.size(); ++i) {
            final String key = keys.get(i);
            String value = (String)params.get(key);
            value = URLEncoder.encode(value, "UTF-8");
            if (i == keys.size() - 1) {
                prestr = prestr + key + "=" + value;
            }
            else {
                prestr = prestr + key + "=" + value + "&";
            }
        }
        return prestr;
    }
    
    public static String query(final Map<String, Object> params, String notifyUrl) {
        String inputLine = "false";
        final StringBuilder b = new StringBuilder();
        try {
            final String p = buildRequestPara(params);
            if (!p.equals("")) {
                notifyUrl = notifyUrl + "?" + p;
            }
            final URL url = new URL(notifyUrl);
            HttpURLConnection urlConnection;
            if (notifyUrl.startsWith("https://")) {
                urlConnection = (HttpsURLConnection)url.openConnection();
            }
            else {
                urlConnection = (HttpURLConnection)url.openConnection();
            }
            final BufferedReader in = new BufferedReader(new InputStreamReader(urlConnection.getInputStream(), "UTF-8"));
            while ((inputLine = in.readLine()) != null) {
                b.append(inputLine);
            }
            inputLine = b.toString();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return inputLine;
    }
    
    public static String query(final String url) {
        final Map<String, Object> map = new HashMap<String, Object>();
        return query(map, url);
    }
}
