package xgs.net.utils;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

public class ObjectUtils
{
    public static Object getCtl(final String ctlPath, final String key) throws Exception {
        final String[] names = key.split("\\.");
        final String className = names[names.length - 1] + "Controller";
        String pac = "";
        for (int i = 0; i < names.length - 1; ++i) {
            pac = pac + names[i].toLowerCase() + ".";
        }
        final String name = ctlPath + pac + StrUtils.firstCharToUpperCase(className);
        return Class.forName(name).newInstance();
    }
    
    public static List<String> getMethodValue(final List<?> list, final String methodName, final String... params) {
        final List<String> result = new ArrayList<String>();
        try {
            for (final Object o : list) {
                final Method method = ReflectionUtils.getMethodLikeName(o, methodName);
                Object re;
                if (params != null) {
                    re = method.invoke(o, (Object[])params);
                }
                else {
                    re = method.invoke(o, new Object[0]);
                }
                if (re != null) {
                    result.add(String.valueOf(re));
                }
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }
    
    public static List<String> getMethodValue(final List<?> list, final String methodName) {
        final List<String> result = new ArrayList<String>();
        try {
            for (final Object o : list) {
                final Method method = ReflectionUtils.getMethodLikeName(o, methodName);
                final Object re = method.invoke(o, new Object[0]);
                if (re != null) {
                    result.add(String.valueOf(re));
                }
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }
    
    public static Field getDeclaredField(final Object object, final String fieldName) {
        Field field = null;
        Class<?> clazz = object.getClass();
        while (clazz != Object.class) {
            try {
                final Field[] fields = clazz.getDeclaredFields();
                field = clazz.getDeclaredField(fieldName);
                return field;
            }
            catch (Exception ex) {
                clazz = clazz.getSuperclass();
                continue;
            }
        }
        return null;
    }
    
    public static void main(final String[] args) throws Exception {
    }
}
