package xgs.net.utils;

import java.util.concurrent.Callable;

public class RetryUtils
{
    public static <V> V retryOnException(final int retryLimit, final Callable<V> retryCallable) {
        V v = null;
        for (int i = 0; i < retryLimit; ++i) {
            try {
                v = retryCallable.call();
            }
            catch (Exception e) {
                System.out.println("retry on " + (i + 1) + " times v = " + v + "\n" + e.getMessage());
            }
        }
        return v;
    }
    
    public static <V> V retryOnException(final int retryLimit, final long sleepMillis, final Callable<V> retryCallable) throws InterruptedException {
        V v = null;
        for (int i = 0; i < retryLimit; ++i) {
            try {
                v = retryCallable.call();
            }
            catch (Exception e) {
                System.out.println("retry on " + (i + 1) + " times v = " + v + "\n" + e.getMessage());
            }
            Thread.sleep(sleepMillis);
        }
        return v;
    }
}
