package xgs.net.utils;

import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

public class ThreadUtils
{
    public static void sleep(final long millis) {
        try {
            Thread.sleep(millis);
        }
        catch (InterruptedException ex) {}
    }
    
    public static void lazyRun(final long millis, final LazyAction lazyAction) {
        final Timer timer = new Timer();
        final TimerTask task = new TimerTask() {
            @Override
            public void run() {
                lazyAction.exec();
                this.cancel();
                timer.cancel();
            }
        };
        timer.schedule(task, millis);
    }
    
    public static void lazyRun(final Date date, final LazyAction lazyAction) {
        final Timer timer = new Timer();
        final TimerTask task = new TimerTask() {
            @Override
            public void run() {
                lazyAction.exec();
                this.cancel();
                timer.cancel();
            }
        };
        timer.schedule(task, date);
    }
    
    public interface LazyAction
    {
        void exec();
    }
}
