package xgs.net.utils;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class TimeUtils
{
    private static String CurrentTime;
    private static String CurrentDate;
    
    public static String getCurrentYear() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy");
        return formatter.format(NowDate);
    }
    
    public static String getHourTime() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("HH:mm:ss");
        return formatter.format(NowDate);
    }
    
    public static String getCurrentMonth() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("MM");
        return formatter.format(NowDate);
    }
    
    public static String getCurrentDay() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("dd");
        return formatter.format(NowDate);
    }
    
    public static String getCurrentTime() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return TimeUtils.CurrentTime = formatter.format(NowDate);
    }
    
    public static String getCurrentCompactTime() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddHHmmss");
        return TimeUtils.CurrentTime = formatter.format(NowDate);
    }
    
    public static String getYearMonthDayStr() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
        return TimeUtils.CurrentTime = formatter.format(NowDate);
    }
    
    public static String getYesterdayCompactTime() {
        final Calendar cal = Calendar.getInstance();
        cal.add(5, -1);
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddHHmmss");
        return TimeUtils.CurrentTime = formatter.format(cal.getTime());
    }
    
    public static String getYesterdayCompactTimeForFileName() {
        final Calendar cal = Calendar.getInstance();
        cal.add(5, -1);
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return TimeUtils.CurrentTime = formatter.format(cal.getTime());
    }
    
    public static String getCurrentDate() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        return TimeUtils.CurrentDate = formatter.format(NowDate);
    }
    
    public static String getCurrentDate1() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy\u5e74MM\u6708dd\u65e5");
        return TimeUtils.CurrentDate = formatter.format(NowDate);
    }
    
    public static String getCurrentFirstDate() {
        final Date NowDate = new Date();
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-01");
        return TimeUtils.CurrentDate = formatter.format(NowDate);
    }
    
    public static String getCurrentLastDate() {
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar = null;
        try {
            final Date date = formatter.parse(getCurrentFirstDate());
            calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.add(2, 1);
            calendar.add(6, -1);
            return formatDate(calendar.getTime());
        }
        catch (ParseException e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static String formatDate(final Date date) {
        return formatDateByFormat(date, "yyyy-MM-dd");
    }
    
    public static String formatDateByFormat(final Date date, final String format) {
        String result = "";
        if (date != null) {
            try {
                final SimpleDateFormat sdf = new SimpleDateFormat(format);
                result = sdf.format(date);
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        return result;
    }
    
    public static String addDay(final String currentdate, final int add_day) {
        GregorianCalendar gc = null;
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        try {
            final int year = Integer.parseInt(currentdate.substring(0, 4));
            final int month = Integer.parseInt(currentdate.substring(5, 7)) - 1;
            final int day = Integer.parseInt(currentdate.substring(8, 10));
            gc = new GregorianCalendar(year, month, day);
            gc.add(5, add_day);
            return formatter.format(gc.getTime());
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static String addMonth(final String currentdate, final int add_month) {
        GregorianCalendar gc = null;
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        try {
            final int year = Integer.parseInt(currentdate.substring(0, 4));
            final int month = Integer.parseInt(currentdate.substring(5, 7)) - 1;
            final int day = Integer.parseInt(currentdate.substring(8, 10));
            gc = new GregorianCalendar(year, month, day);
            gc.add(2, add_month);
            return formatter.format(gc.getTime());
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static int monthDiff(final String beforeTime, final String endTime) {
        if (beforeTime == null || endTime == null) {
            return 0;
        }
        try {
            final int beforeYear = Integer.parseInt(beforeTime.substring(0, 4));
            final int endYear = Integer.parseInt(endTime.substring(0, 4));
            final int beforeMonth = Integer.parseInt(beforeTime.substring(5, 7)) - 1;
            final int endMonth = Integer.parseInt(endTime.substring(5, 7)) - 1;
            return (endYear - beforeYear) * 12 + (endMonth - beforeMonth);
        }
        catch (Exception e) {
            e.printStackTrace();
            return 0;
        }
    }
    
    public static String addMinute(final String currentdatetime, final int add_minute) {
        GregorianCalendar gc = null;
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            final int year = Integer.parseInt(currentdatetime.substring(0, 4));
            final int month = Integer.parseInt(currentdatetime.substring(5, 7)) - 1;
            final int day = Integer.parseInt(currentdatetime.substring(8, 10));
            final int hour = Integer.parseInt(currentdatetime.substring(11, 13));
            final int minute = Integer.parseInt(currentdatetime.substring(14, 16));
            final int second = Integer.parseInt(currentdatetime.substring(17, 19));
            gc = new GregorianCalendar(year, month, day, hour, minute, second);
            gc.add(12, add_minute);
            return formatter.format(gc.getTime());
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static String reductionMinute(final String currentdatetime, final int minute) {
        final GregorianCalendar gc = null;
        final SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            final Date date = format.parse(currentdatetime);
            final long Time = date.getTime() / 1000L - 60 * minute;
            date.setTime(Time * 1000L);
            return format.format(date.getTime());
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static String addSecond(final String currentdatetime, final int add_second) {
        GregorianCalendar gc = null;
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            final int year = Integer.parseInt(currentdatetime.substring(0, 4));
            final int month = Integer.parseInt(currentdatetime.substring(5, 7)) - 1;
            final int day = Integer.parseInt(currentdatetime.substring(8, 10));
            final int hour = Integer.parseInt(currentdatetime.substring(11, 13));
            final int minute = Integer.parseInt(currentdatetime.substring(14, 16));
            final int second = Integer.parseInt(currentdatetime.substring(17, 19));
            gc = new GregorianCalendar(year, month, day, hour, minute, second);
            gc.add(13, add_second);
            return formatter.format(gc.getTime());
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static String addMinute1(final String currentdatetime, final int add_minute) {
        GregorianCalendar gc = null;
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddHHmmss");
        try {
            final int year = Integer.parseInt(currentdatetime.substring(0, 4));
            final int month = Integer.parseInt(currentdatetime.substring(5, 7)) - 1;
            final int day = Integer.parseInt(currentdatetime.substring(8, 10));
            final int hour = Integer.parseInt(currentdatetime.substring(8, 10));
            final int minute = Integer.parseInt(currentdatetime.substring(8, 10));
            final int second = Integer.parseInt(currentdatetime.substring(8, 10));
            gc = new GregorianCalendar(year, month, day, hour, minute, second);
            gc.add(12, add_minute);
            return formatter.format(gc.getTime());
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    
    public static Date parseDate(final String sDate) {
        final SimpleDateFormat bartDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        try {
            final Date date = bartDateFormat.parse(sDate);
            return date;
        }
        catch (Exception ex) {
            return null;
        }
    }
    
    public static Date parseDate2(final String sDate) {
        final SimpleDateFormat bartDateFormat = new SimpleDateFormat("yyyy/MM/dd");
        try {
            final Date date = bartDateFormat.parse(sDate);
            return date;
        }
        catch (Exception ex) {
            return null;
        }
    }
    
    public static Date parseDateTime(final String sDateTime) {
        final SimpleDateFormat bartDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            final Date date = bartDateFormat.parse(sDateTime);
            return date;
        }
        catch (Exception ex) {
            return null;
        }
    }
    
    public static int getTotalDaysOfMonth(final String strDate) {
        final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        final Calendar calendar = new GregorianCalendar();
        Date date = null;
        try {
            date = sdf.parse(strDate);
            calendar.setTime(date);
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        final int day = calendar.getActualMaximum(5);
        return day;
    }
    
    public static long getDateSubDay(final String startDate, final String endDate) {
        final Calendar calendar = Calendar.getInstance();
        final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        long theday = 0L;
        try {
            calendar.setTime(sdf.parse(startDate));
            final long timethis = calendar.getTimeInMillis();
            calendar.setTime(sdf.parse(endDate));
            final long timeend = calendar.getTimeInMillis();
            theday = (timeend - timethis) / 86400000L;
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return theday;
    }
    
    public static String getPlusTime(final String sDateTime, final String eDateTime) throws ParseException {
        final SimpleDateFormat myFormatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        final Date ssDateTime = myFormatter.parse(sDateTime);
        final Date eeDateTime = myFormatter.parse(eDateTime);
        final long l = eeDateTime.getTime() - ssDateTime.getTime();
        final long day = l / 86400000L;
        final long hour = l / 3600000L - day * 24L;
        final long min = l / 60000L - day * 24L * 60L - hour * 60L;
        final long s = l / 1000L - day * 24L * 60L * 60L - hour * 60L * 60L - min * 60L;
        return "" + day + "\u5929" + hour + "\u5c0f\u65f6" + min + "\u5206" + s + "\u79d2";
    }
    
    public static String getTimeDifferent(final String sDateTime, final String eDateTime) throws ParseException {
        final SimpleDateFormat myFormatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        final Date ssDateTime = myFormatter.parse(sDateTime);
        final Date eeDateTime = myFormatter.parse(eDateTime);
        final long l = eeDateTime.getTime() - ssDateTime.getTime();
        final long hour = l / 3600000L;
        final long min = l / 60000L - hour * 60L;
        final long s = l / 1000L - hour * 60L * 60L - min * 60L;
        return hour + "\u5c0f\u65f6" + min + "\u5206" + s + "\u79d2";
    }
    
    public static int getTime(final String sDateTime, final String eDateTime) throws ParseException {
        final SimpleDateFormat myFormatter = new SimpleDateFormat("yyyy-MM-dd");
        final Date ssDateTime = myFormatter.parse(sDateTime);
        final Date eeDateTime = myFormatter.parse(eDateTime);
        final long l = eeDateTime.getTime() - ssDateTime.getTime();
        final long day = l / 86400000L;
        return (int)day;
    }
    
    public static long getPlusTotalTime(final String sDateTime, final String eDateTime) throws ParseException {
        final SimpleDateFormat myFormatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        final Date ssDateTime = myFormatter.parse(sDateTime);
        final Date eeDateTime = myFormatter.parse(eDateTime);
        return eeDateTime.getTime() - ssDateTime.getTime();
    }
    
    public static String getWeek(final String sdate) {
        final Date date = strToDate(sdate);
        final Calendar c = Calendar.getInstance();
        c.setTime(date);
        return new SimpleDateFormat("EEEE").format(c.getTime());
    }
    
    public static Date strToDate(final String strDate) {
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        final ParsePosition pos = new ParsePosition(0);
        final Date strtodate = formatter.parse(strDate, pos);
        return strtodate;
    }
    
    public static String convertToString(final Date date) {
        final SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
        try {
            return formatter.format(date);
        }
        catch (Exception e) {
            return null;
        }
    }
    
    public static String getTwoDay(final String sj1, final String sj2) {
        final SimpleDateFormat myFormatter = new SimpleDateFormat("yyyy-MM-dd");
        long day = 0L;
        try {
            final Date date = myFormatter.parse(sj1);
            final Date mydate = myFormatter.parse(sj2);
            day = (date.getTime() - mydate.getTime()) / 86400000L;
        }
        catch (Exception e) {
            return "";
        }
        return day + "";
    }
    
    public static String formatDataStr(final String dataStr, final String formatStr) {
        final Date date = strToDate(dataStr);
        return formatDateByFormat(date, formatStr);
    }
    
    public static String getTimeByMillis(final long now) throws ParseException {
        final DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        final Calendar calendar = Calendar.getInstance();
        calendar.setTimeInMillis(now);
        return formatter.format(calendar.getTimeInMillis());
    }
    
    public static String dayForWeek(final String pTime) throws Exception {
        String resultStr = "\u661f\u671f";
        final SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        final Calendar c = Calendar.getInstance();
        c.setTime(format.parse(pTime));
        int dayForWeek = 0;
        if (c.get(7) == 1) {
            dayForWeek = 7;
        }
        else {
            dayForWeek = c.get(7) - 1;
        }
        switch (dayForWeek) {
            case 1: {
                resultStr += "\u4e00";
                break;
            }
            case 2: {
                resultStr += "\u4e8c";
                break;
            }
            case 3: {
                resultStr += "\u4e09";
                break;
            }
            case 4: {
                resultStr += "\u56db";
                break;
            }
            case 5: {
                resultStr += "\u4e94";
                break;
            }
            case 6: {
                resultStr += "\u516d";
                break;
            }
            case 7: {
                resultStr += "\u65e5";
                break;
            }
        }
        return resultStr;
    }
    
    public static String formatDate(final String date) throws Exception {
        String result = "";
        if (!StrUtils.isBlank(date)) {
            result = date.replaceAll("-", "");
            result = result.substring(0, 8);
        }
        return result;
    }
}
