package xgs.net.utils.tree;

import java.util.ArrayList;
import java.util.List;

public abstract class TreeNode {
    public TreeNode()
    {
    }

    public TreeNode(String id, String pId, String name)
    {
        this.id = id;
        this.pId = pId;
        this.label = name;
    }



    private String id;
    /**
     * 跟节点的pid=0
     */
    private String pId;
    private String label;
    /**
     * 树的层级
     */
    private int level;

    private TreeNode parent;

    private List<TreeNode> children = new ArrayList<TreeNode>();

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public String getpId()
    {
        return pId;
    }

    public void setpId(String pId)
    {
        this.pId = pId;
    }

    public String getLabel()
    {
        return label;
    }

    public void setLabel(String label)
    {
        this.label = label;
    }

    public List<TreeNode> getChildren()
    {
        return children;
    }

    public void setChildren(List<TreeNode> children)
    {
        this.children = children;
    }


    public TreeNode getParent()
    {
        return parent;
    }

    public void setParent(TreeNode parent)
    {
        this.parent = parent;
    }


    /**
     * 是否是叶子节点
     *
     * @return
     */
    public boolean isLeaf()
    {
        return children.size() == 0;
    }





    public void setLevel(int level)
    {
        this.level = level;
    }

}
