package xgs.net;

import com.jfinal.kit.HashKit;
import com.jfinal.kit.Prop;
import com.jfinal.kit.PropKit;
import com.jfinal.kit.StrKit;
import com.jfinal.weixin.iot.msg.InEquDataMsg;
import com.jfinal.weixin.iot.msg.InEqubindEvent;
import com.jfinal.weixin.sdk.api.ApiConfigKit;
import com.jfinal.weixin.sdk.api.JsTicket;
import com.jfinal.weixin.sdk.api.JsTicketApi;
import com.jfinal.weixin.sdk.jfinal.MsgController;
import com.jfinal.weixin.sdk.msg.in.*;
import com.jfinal.weixin.sdk.msg.in.card.*;
import com.jfinal.weixin.sdk.msg.in.event.*;
import com.jfinal.weixin.sdk.msg.in.speech_recognition.InSpeechRecognitionResults;
import xgs.net.annotation.ControllerKey;
import xgs.net.entity.Msg;
import xgs.net.util.AsyncUpload;
import xgs.net.utils.IdGen;

import java.io.IOException;
import java.util.Map;
import java.util.TreeMap;

@ControllerKey("/msg")
public class WxMsgController extends MsgController
{
    Prop prop  = PropKit.use("app.properties");


    public void jsApi() {
        String url = this.getPara("url");
        final JsTicket _wxJsApiTicket = JsTicketApi.getTicket(JsTicketApi.JsApiType.jsapi);
        final String _wxNoncestr = StrKit.getRandomUUID();
        final String _wxTimestamp = System.currentTimeMillis() / 1000L + "";
        final String _url = url;//this.prop.get("wx.url");
        final Map<String, String> _wxMap = new TreeMap<>();
        _wxMap.put("noncestr", _wxNoncestr);
        _wxMap.put("timestamp", _wxTimestamp);
        _wxMap.put("jsapi_ticket", _wxJsApiTicket.getTicket());
        _wxMap.put("url", _url);
        final StringBuilder _wxBaseString = new StringBuilder();
        for (final Map.Entry<String, String> param : _wxMap.entrySet()) {
            _wxBaseString.append(param.getKey()).append("=").append(param.getValue()).append("&");
        }
        final String _wxSignString = _wxBaseString.substring(0, _wxBaseString.length() - 1);
        final String _wxSignature = HashKit.sha1(_wxSignString);
        _wxMap.put("signature", _wxSignature);
        _wxMap.put("nonceStr", _wxNoncestr);
        _wxMap.put("appId", ApiConfigKit.getApiConfig().getAppId());
        _wxMap.remove("jsapi_ticket");
        this.renderJson(_wxMap);
    }

    public void getMediaFile() throws IOException {
        final String serverId = this.getPara("server_id");
        final Long id = IdGen.getId();
        final AsyncUpload upload = new AsyncUpload();
        upload.wxUpload(serverId, id);
        final Msg msg = new Msg();
        msg.setData(id);
        this.renderJson(msg);
    }

    protected void processInTextMsg(final InTextMsg inTextMsg) {
    }

    protected void processInImageMsg(final InImageMsg inImageMsg) {
    }

    protected void processInVoiceMsg(final InVoiceMsg inVoiceMsg) {
    }

    protected void processInVideoMsg(final InVideoMsg inVideoMsg) {
    }

    protected void processInShortVideoMsg(final InShortVideoMsg inShortVideoMsg) {
    }

    protected void processInLocationMsg(final InLocationMsg inLocationMsg) {
    }

    protected void processInLinkMsg(final InLinkMsg inLinkMsg) {
    }

    protected void processInCustomEvent(final InCustomEvent inCustomEvent) {
    }

    protected void processInFollowEvent(final InFollowEvent inFollowEvent) {
    }

    protected void processInQrCodeEvent(final InQrCodeEvent inQrCodeEvent) {
    }

    protected void processInLocationEvent(final InLocationEvent inLocationEvent) {
    }

    protected void processInMassEvent(final InMassEvent inMassEvent) {
    }

    protected void processInMenuEvent(final InMenuEvent inMenuEvent) {
    }

    protected void processInSpeechRecognitionResults(final InSpeechRecognitionResults inSpeechRecognitionResults) {
    }

    protected void processInTemplateMsgEvent(final InTemplateMsgEvent inTemplateMsgEvent) {
    }

    protected void processInShakearoundUserShakeEvent(final InShakearoundUserShakeEvent inShakearoundUserShakeEvent) {
    }

    protected void processInVerifySuccessEvent(final InVerifySuccessEvent inVerifySuccessEvent) {
    }

    protected void processInVerifyFailEvent(final InVerifyFailEvent inVerifyFailEvent) {
    }

    protected void processInPoiCheckNotifyEvent(final InPoiCheckNotifyEvent inPoiCheckNotifyEvent) {
    }

    protected void processInWifiEvent(final InWifiEvent inWifiEvent) {
    }

    protected void processInUserCardEvent(final InUserCardEvent inUserCardEvent) {
    }

    protected void processInUpdateMemberCardEvent(final InUpdateMemberCardEvent inUpdateMemberCardEvent) {
    }

    protected void processInUserPayFromCardEvent(final InUserPayFromCardEvent inUserPayFromCardEvent) {
    }

    protected void processInMerChantOrderEvent(final InMerChantOrderEvent inMerChantOrderEvent) {
    }

    protected void processIsNotDefinedEvent(final InNotDefinedEvent inNotDefinedEvent) {
    }

    protected void processIsNotDefinedMsg(final InNotDefinedMsg inNotDefinedMsg) {
    }

    protected void processInUserGiftingCardEvent(final InUserGiftingCardEvent inUserGiftingCardEvent) {
    }

    protected void processInUserGetCardEvent(final InUserGetCardEvent inUserGetCardEvent) {
    }

    protected void processInUserConsumeCardEvent(final InUserConsumeCardEvent inUserConsumeCardEvent) {
    }

    protected void processInCardSkuRemindEvent(final InCardSkuRemindEvent inCardSkuRemindEvent) {
    }

    protected void processInCardPayOrderEvent(final InCardPayOrderEvent inCardPayOrderEvent) {
    }

    protected void processInCardPassCheckEvent(final InCardPassCheckEvent inCardPassCheckEvent) {
    }

    protected void processInEqubindEvent(final InEqubindEvent inEqubindEvent) {
    }

    protected void processInEquDataMsg(final InEquDataMsg inEquDataMsg) {
    }
}
