package xgs.net.commons;

import com.jfinal.config.Constants;
import com.jfinal.config.Handlers;
import com.jfinal.config.Interceptors;
import com.jfinal.config.Plugins;
import com.jfinal.kit.Prop;
import com.jfinal.kit.PropKit;
import com.jfinal.weixin.sdk.api.ApiConfig;
import com.jfinal.weixin.sdk.api.ApiConfigKit;
import com.jfinal.weixin.sdk.cache.RedisAccessTokenCache;
import xgs.net.init.XgsConfig;
import xgs.net.interceptors.JsonInterceptor;
import xgs.net.plugin.IocPlugin;
import xgs.net.session.SessionRepositoryRequestWrapper;
import xgs.net.utils.MyJsonFactory;

public class Config extends XgsConfig
{
    private Prop cfg;
    private Prop prop;
    private boolean isLocalDev;
    
    public Config() {
        this.cfg = PropKit.use("cfg.properties");
        this.prop = PropKit.use("app.properties");
        this.isLocalDev = false;
    }
    
    public void constant(final Constants me) {
        me.setJsonFactory(new MyJsonFactory());
    }
    
    public void plugin(final Plugins me) {
        final String[] pkgs = { "xgs.net" };
        final IocPlugin ioc = new IocPlugin(pkgs);
        me.add(ioc);
        this.routes.add(ioc.getRoutes());
    }
    
    public void interceptor(final Interceptors me) {

    }
    
    public void handler(final Handlers me) {
    }
    
    public void afterJFinalStart() {
        super.afterJFinalStart();
        ApiConfigKit.setAccessTokenCache(new RedisAccessTokenCache(this.cfg.get("cache.redis.wx.name")));
        ApiConfig ac = new ApiConfig();
        ac.setToken(this.prop.get("wx.token"));
        ac.setAppId(this.prop.get("wx.appId"));
        ac.setAppSecret(this.prop.get("wx.appSecret"));
        ac.setEncryptMessage(this.prop.getBoolean("wx.encryptMessage", false));
        ac.setEncodingAesKey(this.prop.get("wx.encodingAesKey", "setting it in config file"));
        ApiConfigKit.putApiConfig(ac);
        if (this.cfg.getBoolean("session.enable", false)) {
            SessionRepositoryRequestWrapper.initCfg(this.prop.get("wx.session.clazz"), this.prop.getInt("wx.session.maxAgeInSeconds", 30), this.prop.get("wx.session.cookieName"), this.cfg.get("cache.redis.wx.name"));
        }
    }
}
