package xgs.net.dev;

import com.jfinal.core.JFinalFilter;
import io.undertow.Handlers;
import io.undertow.Undertow;
import io.undertow.server.HttpHandler;
import io.undertow.server.handlers.PathHandler;
import io.undertow.servlet.Servlets;
import io.undertow.servlet.api.DeploymentInfo;
import io.undertow.servlet.api.DeploymentManager;
import io.undertow.servlet.api.FilterInfo;
import xgs.net.WxStart;

import javax.servlet.DispatcherType;
import javax.servlet.ServletException;

public class UndertowStatter implements Startter
{
    @Override
    public void start() throws ServletException {
        final String MYAPP = "/";
        final DeploymentInfo di = Servlets.deployment().setClassLoader(WxStart.class.getClassLoader()).setDeploymentName("app.war").setContextPath(MYAPP);
        di.setEagerFilterInit(true);
        final FilterInfo info = new FilterInfo("jfinal", (Class)JFinalFilter.class);
        info.addInitParam("configClass", UndertowStatter.prop.get("system.start.configClazz"));
        di.addFilter(info);
        di.addFilterUrlMapping("jfinal", "/*", DispatcherType.REQUEST);
        final DeploymentManager manager = Servlets.defaultContainer().addDeployment(di);
        manager.deploy();
        final HttpHandler servletHandler = manager.start();
        final PathHandler path = Handlers.path(servletHandler);
        final Undertow server = Undertow.builder().addHttpListener((int)UndertowStatter.prop.getInt("system.start.port", 80), "0.0.0.0").setHandler((HttpHandler)path).build();
        server.start();
    }
}
