package xgs.net.util;

import com.jfinal.kit.Prop;
import com.jfinal.kit.PropKit;
import com.jfinal.weixin.sdk.api.AccessTokenApi;
import com.jfinal.weixin.sdk.api.MediaApi;
import com.jfinal.weixin.sdk.api.MediaFile;
import okhttp3.*;
import xgs.net.utils.ByteUtils;
import xgs.net.utils.IdGen;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.TimeUnit;

public class AsyncUpload
{
    Prop prop;
    
    public AsyncUpload() {
        this.prop = PropKit.use("app.properties");
    }
    
    public void wxUpload(final String serverId, final Long id) throws IOException {
        new Thread(new upload(serverId, id)).start();
    }
    
    public static void main(final String[] args) throws IOException {
        final AsyncUpload upload = new AsyncUpload();
        upload.wxUpload("aaa", IdGen.getId());
    }
    
    class upload implements Runnable
    {
        private String serverId;
        private Long id;
        
        public upload(final String serverId, final Long id) {
            this.serverId = serverId;
            this.id = id;
        }
        
        @Override
        public void run() {
            try {
                final OkHttpClient client = new OkHttpClient.Builder().connectTimeout(10L, TimeUnit.SECONDS).readTimeout(10L, TimeUnit.SECONDS).build();
                System.out.println(this.serverId);
                final MediaFile mediaFile = MediaApi.getMedia(this.serverId);
                final String token = AccessTokenApi.getAccessTokenStr();
                System.out.println(token);
                System.out.println(mediaFile.getContentLength());
                System.out.println(mediaFile.getFileStream());
                if (mediaFile.getContentType() == null) {
                    mediaFile.setContentType("image/jpeg");
                }
                final RequestBody fileBody = RequestBody.create(MediaType.parse(mediaFile.getContentType()), ByteUtils.is2byte((InputStream)mediaFile.getFileStream()));
                final RequestBody requestBody = (RequestBody)new MultipartBody.Builder().setType(MultipartBody.FORM).addFormDataPart("appendix", mediaFile.getFullName(), fileBody).addFormDataPart("id", String.valueOf(this.id)).build();
                final Request requestPostFile = new Request.Builder().url(AsyncUpload.this.prop.get("upload.url")).post(requestBody).build();
                client.newCall(requestPostFile).enqueue((Callback)new Callback() {
                    public void onFailure(final Call call, final IOException e) {
                        e.printStackTrace();
                        call.cancel();
                    }
                    
                    public void onResponse(final Call call, final Response response) throws IOException {
                        System.out.println(response.body().string());
                        call.cancel();
                    }
                });
            }
            catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
