import Bridge from './bridge'
export class AndroidBridge extends Bridge {
  _setupWebViewJavascriptBridge (callback) {
    if (window.WebViewJavascriptBridge) {
      callback(window.WebViewJavascriptBridge)
    } else {
      document.addEventListener(
        'WebViewJavascriptBridgeReady'
        , function () {
          callback(window.WebViewJavascriptBridge)
        },
        false
      )
    }
  }
  init (callback) {
    this._setupWebViewJavascriptBridge(bridge => {
      if (this.bridge) {
        callback(this.bridge)
        return
      }
      bridge.init(function (message, responseCallback) {
        // debugger
        if (responseCallback) {
          responseCallback(message)
        }
      })
      this.bridge = bridge
      callback(this.bridge)
    })
  }
}
let bridge = new AndroidBridge()
export default bridge
