import Bridge from './bridge'
export class IosBridge extends Bridge {
  _setupWebViewJavascriptBridge (callback) {
    if (window.WebViewJavascriptBridge) {
      return callback(window.WebViewJavascriptBridge)
    }
    if (window.WVJBCallbacks) {
      return window.WVJBCallbacks.push(callback)
    }
    window.WVJBCallbacks = [callback]
    var WVJBIframe = document.createElement('iframe')
    WVJBIframe.style.display = 'none'
    WVJBIframe.src = 'https://__bridge_loaded__'
    document.documentElement.appendChild(WVJBIframe)
    setTimeout(function () {
      document.documentElement.removeChild(WVJBIframe)
    }, 0)
  }
  init (callback) {
    this._setupWebViewJavascriptBridge(bridge => {
      if (this.bridge) {
        callback(this.bridge)
        return
      }
      this.bridge = bridge
      callback(this.bridge)
    })
  }
}
let bridge = new IosBridge()
export default bridge
