import wx from 'weixin-js-sdk'
// import http from '../http/impl/weixin'
import axios from 'axios'
import Bridge from './bridge'
import { url } from '../const'
// import {qs} from 'qs'

export const shareArray = [
  'onMenuShareTimeline', // 分享到朋友圈
  'onMenuShareAppMessage', // 分享给朋友
  'onMenuShareQQ', // 分享到QQ
  'onMenuShareWeibo', // 分享到腾讯微博
  'onMenuShareQZone' // 分享到QQ空间
]
export class WeixinBridge extends Bridge {
  // TODO 获取微信授权
  init (callback) {
    axios
      .get(url + 'msg/jsApi?url=' + window.location.href)
      .then(res => {
        let jsApiList = [
          'chooseWXPay', // 微信支付
          'chooseImage', // 拍照或从手机相册中选图接口
          'previewImage', // 预览图片接口
          'uploadImage', // 上传图片接口
          'downloadImage', // 下载图片接口
          'getLocalImgData', // 获取本地图片接口
          'openLocation', // 使用微信内置地图查看位置接口
          'getLocation', // 获取地理位置接口
          ...shareArray
        ]
        wx.config({
          debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
          appId: res.data.appId, // 必填，公众号的唯一标识
          timestamp: res.data.timestamp, // 必填，生成签名的时间戳
          nonceStr: res.data.nonceStr, // 必填，生成签名的随机串
          signature: res.data.signature, // 必填，签名
          jsApiList // 必填，需要使用的JS接口列表
        })
        wx.ready(() => {
          window.share.config = {
            title: '城市动态',
            desc: '城市动态',
            link: 'http://wx.vipweizha.cn',
            imgUrl: ''
          }
          // wx.showAllNonBaseMenuItem()
          // // 分享到朋友圈
          // wx.onMenuShareTimeline(window.share.config)
          // // 分享到朋友
          // wx.onMenuShareAppMessage(window.share.config)
          // // 分享到QQ
          // wx.onMenuShareQQ(window.share.config)
          // // 分享到腾讯微博
          // wx.onMenuShareWeibo(window.share.config)
          // // 分享到QQ空间
          // wx.onMenuShareQZone(window.share.config)
          callback()
        })
      })
      .catch(e => {
        // 错误处理
      })
  }
}
let bridge = new WeixinBridge()
export default bridge
