import {url, networkTimeOut} from '../const'
export default class HttpInterface {
  constructor () {
    this.url = url
    this.timeout = networkTimeOut
  }
  /**
   * params:{
   *  id:1,
   *  name:'json',
   *  etc...
   * }
   * @param {Object} data
   *
   * @returns {String}
   * returns id=1&c=abc...
   */
  _params (data) {
    let url = ''
    for (let k in data) {
      let value = data[k] !== undefined ? data[k] : ''
      url += `&${k}=${encodeURIComponent(value)}`
    }
    return url ? url.substring(1) : ''
  }
  /**
   * http请求get方法
   * url 只能为路径，不可以带参数
   *  eg: http://xxxx/ip OK
   *      http://xxxx/ip?id=1 ERROR
   * params:{
   *  id:1,
   *  name:'json',
   *  etc...
   * }
   * @param {String} _url
   * @param {Object} params
   *
   * @returns {Promise}
   * {code:200,msg:'',data:Object} 成功时反回
   * {code:!200,msg:''} 失败时返回
   */
  get (url, params) {
    throw new Error('not implementation the get method.')
  }
  /**
   *
   * http请求post方法
   * url 只能为路径，不可以带参数
   *  eg: http://xxxx/ip OK
   *      http://xxxx/ip?id=1 ERROR
   * params:{
   *  id:1,
   *  name:'json',
   *  etc...
   * }
   *
   * @param {String} url
   * @param {Object} params
   *
   * @returns {Promise}
   * {code:200,msg:'',data:Object} 成功时反回
   * {code:!200,msg:''} 失败时返回
   */
  post (url, params) {
    throw new Error('not implementation the post method.')
  }
}
