import HttpInterface from '../http'
import bridge from 'Bridge'

export class App extends HttpInterface {
  get (_url, params) {
    return new Promise((resolve, reject) => {
      bridge.init((b) => {
        b.callHandler('httpUtils', {
          method: 'get',
          url: this.url + _url,
          timeout: this.timeout,
          params: JSON.stringify(params)
        }, (res) => {
          resolve(JSON.parse(res))
        })
      })
    })
  }
  post (_url, params) {
    return new Promise((resolve, reject) => {
      bridge.init(function (b) {
        b.callHandler('httpUtils', {
          method: 'post',
          url: this.url + _url,
          timeout: this.timeout,
          params: JSON.stringify(params)
        }, (res) => {
          resolve(JSON.parse(res))
        })
      })
    })
  }
}
