import ImageInterface from './imageInterface'
import bridge from 'Bridge'
export class App extends ImageInterface {
  openImage (max) {
    return new Promise((resolve, reject) => {
      bridge.init((b) => {
        b.callHandler('openImage', { max }, (res) => {
          let {compress, data} = JSON.parse(res)
          data = data || []
          let localIds = []
          data.forEach((item, index) => {
            if (item.path) {} else {
              item.path = item.src
            }
            localIds.push(item)
          })
          let ret = {
            compress,
            localIds
          }
          resolve(ret)
        })
      })
    })
  }
  uploadImage (compress, url, data) {
    return new Promise((resolve, reject) => {
      bridge.init((b) => {
        b.callHandler('uploadImage', { compress, url, data }, (res) => {
          resolve(JSON.parse(res))
        })
      })
    })
  }

  avator (size) {
    return new Promise((resolve, reject) => {
      bridge.init((b) => {
        b.callHandler('avatorImage', { size }, (res) => {
          resolve(JSON.parse(res))
        })
      })
    })
  }
}
