
export default class ImageInterface {
  /**
   * 选择图像接口
   *
   * @param {Number} max 最大可选值
   *
   * @returns {Promise} 返回图像地址列表
   * {
   *  compress:true,//是否压缩
   *  data:[
   *    {
   *      type:'image/png',
   *      src:'path',
   *      path:'path'
   *    }
   *    ...
   *  ]
   * }
   */
  openImage (max) {
    throw new Error('打开图像没实现')
  }
  /**
   * 上传图像接口
   * {
   *  compress:true,
   *  url:'',
   *  data:[{src:'',path:path1'},.....]
   * }
   * @param {Boolean} compress 是否要压缩上传
   * @param {String} url 要上传服务器地址
   * @param {Array} paths 要上传的图片地址列表
   *
   * @returns {Promise}
   * [
   *  {src:'path1','succ':true,'id':''}...
   * ]
   */
  uploadImage (compress, url, paths) {
    throw new Error('图像上传没实现')
  }
  /**
   *
   * @param {Number} size 剪切大小
   *
   * @returns {Promise}
   * {
   *  src:'',
   *  path:''
   * }
   */
  avator (size) {
    throw new Error('选择头像没实现')
  }

  preview (current, urls) {
    throw new Error('图片预览错误')
  }
}
