import Location from '../location'
import wx from 'weixin-js-sdk'
import mapConvert from '@/common/js/map.convert'
export class Weixin extends Location {
  getLocation () {
    return new Promise((resolve, reject) => {
      wx.ready(() => {
        wx.getLocation({
          type: 'gcj02', // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
          success (res) {
            let point = mapConvert.bdEncrypt(res.latitude, res.longitude)
            let ret = {
              code: 200,
              data: {
                lat: point.lat,
                lng: point.lng
              }
            }
            resolve(ret)
          },
          cancel () {
            let ret = {
              code: 201,
              msg: '取消定位'
            }
            resolve(ret)
          }
        })
      })
    })
  }
  getNavigationList () {
    return new Promise((resolve, reject) => {
      let ret = {
        code: 200,
        data: []
      }
      resolve(ret)
    })
  }
  Navigation (type, lat, lng, name) {
    name = name || ''
    let ret = mapConvert.bdDecrypt(lat, lng)
    wx.openLocation({
      type: 'gcj02',
      scale: 20,
      name,
      latitude: ret.lat, // 纬度，浮点数，范围为90 ~ -90
      longitude: ret.lng // 经度，浮点数，范围为180 ~ -180。
    })
  }
  covent2Baidu (lat, lng) {
    return new Promise((resolve, reject) => {
      resolve(mapConvert.bdEncrypt(lat, lng))
    })
  }
}

let location = new Weixin()
export default location
