import mapConvert from '@/common/js/map.convert'
export default class Location {
  /**
   * 获取定位
   */
  getLocation () {
    throw new Error('未实现定位代码')
  }
  /**
   * 获取可用导航列表
   */
  getNavigationList () {
    throw new Error('未实现导航代码')
  }
  /**
   *
   * @param {String} type 要定位的地图名称
   * @param {Number} lat 纬度
   * @param {Number} lng 经度
   */
  Navigation (type, lat, lng) {
    throw new Error('未实现导航代码')
  }
  /**
   *
   * @param {Number} lat 纬度
   * @param {Number} lng 经度
   *
   * @returns {Object}
   * {
   *  lat:number,
   *  lng:number
   * }
   */
  covent2Baidu (lat, lng) {
    throw new Error('未实现导航代码')
  }
  /**
   *
   * @param {String} type 要转换为的地理坐标系，比如bd_09,wgs-84,gcj etc...
   * @param {Number} lat 纬度
   * @param {Number} lng 经度
   *
   * @returns {Object}
   * {
   *  lat:number,
   *  lng:number
   * }
   */
  convert4type (type, lat, lng) {
    return mapConvert.gcjEncrypt(lat, lng)
  }
}
