import ShareInterface from '../share'
import bridge from 'Bridge'
export class App extends ShareInterface {
  init (title, desc, imageUrl, toUrl) {
    if (this.isShare) {
      this._config = {
        title,
        desc,
        link: toUrl,
        imgUrl: imageUrl
      }
    }
  }
  getShareList () {
    return new Promise((resolve, reject) => {
      if (this.shareList) {
        resolve(this.shareList)
        return
      }
      bridge.init((b) => {
        b.callHandler('shareList', {}, (res) => {
          this.shareList = this._shareList(JSON.parse(res))
          resolve(this.shareList)
        })
      })
    })
  }
  share (type) {
    this._config.type = type
    return new Promise((resolve, reject) => {
      bridge.init((b) => {
        b.callHandler('shareUtils', this._config, (res) => {
          resolve(JSON.parse(res))
        })
      })
    })
  }
}
