import ShareInterface from '../share'
import wx from 'weixin-js-sdk'
export class Weixin extends ShareInterface {
  init (title, desc, imageUrl, toUrl) {
    if (!this.isShare) {
      wx.hideAllNonBaseMenuItem()
    } else {
      window.share.config = {
        title,
        desc,
        link: toUrl,
        imgUrl: imageUrl
      }
      // alert(JSON.stringify(window.share.config))
      // // 分享到朋友圈
      // wx.onMenuShareTimeline(this._config)
      // // 分享到朋友
      // wx.onMenuShareAppMessage(this._config)
      // // 分享到QQ
      // wx.onMenuShareQQ(this._config)
      // // 分享到腾讯微博
      // wx.onMenuShareWeibo(this._config)
      // // 分享到QQ空间
      // wx.onMenuShareQZone(this._config)
      // wx.showAllNonBaseMenuItem()
    }
  }
  getShareList () {
    return new Promise((resolve, reject) => {
      if (this.shareList) {
        resolve(this.shareList)
        return
      }
      let items = [
        'wechat',
        'wechatFriends',
        'qq',
        'qqWeibo',
        'qzone'
      ]
      this.shareList = this._shareList(items)
      resolve(this.shareList)
    })
  }
  share (type) {
    return new Promise((resolve, reject) => {
      this._config.success = () => {
        let _obj = {
          code: 200,
          msg: '分享成功',
          data: {}
        }
        resolve(_obj)
      }
      this._config.cancel = () => {
        let _obj = {
          code: 201,
          msg: '分享取消'
        }
        resolve(_obj)
      }
    })
  }
}
let share = new Weixin()
export default share
