import ShareException from './ShareException'
import base from './base'
export default class ShareInterface {
  constructor () {
    this.isShare = true
  }
  init (title, desc, imageUrl, toUrl) {
    throw new ShareException(100, '未实现的代码,获取分享列表')
  }
  disabled () {
    this.isShare = false
  }
  enabled () {
    this.isShare = true
  }
  _shareList (items) {
    let _obj = {}
    let keys = Object.keys(base)
    for (let item of items) {
      if (keys.find(n => item === n)) {
        _obj[item] = base[item]
      }
    }

    this.shareList = _obj
    return this.shareList
  }

  /**
   * 获取分享列表
   * @returns {Object} 参见base.js
   */
  getShareList () {
    throw new ShareException(100, '未实现的代码,获取分享列表')
  }
  /**
   *
   * @param {String} type 分享类型，参见base.js的method属性
   * @param {String} title 要分享的标题
   * @param {String} desc 要分享的摘要
   * @param {String} imageUrl 分享要展示的图片url
   * @param {String} toUrl 分享后打开的url
   */
  share (type, title, desc, imageUrl, toUrl) {
    throw new ShareException(100, '未实现的代码，分享实现')
  }
}
