import jsonp from 'jsonp'
class BaiduMap {
  constructor (options) {
    if (!options || !options.ak) {
      throw new TypeError('required ak')
    }
    this.ak = options.ak
  }
  invoke () {
    return new Promise((resolve, reject) => {
      if (this.BMap) {
        resolve(this.BMap)
        return
      }
      window._initBaiduMap = () => {
        this.BMap = window.BMap
        resolve(this.BMap)
      }
      let script = document.createElement('script')
      script.type = 'text/javascript'
      script.src = `http://api.map.baidu.com/api?v=2.0&ak=${
        this.ak
      }&callback=_initBaiduMap`
      document.body.appendChild(script)
    })
  }
}
let options = {
  ak: 'rqAh2byzFT7FKGSHpkcgqvNQ'
}

export function getBaiduLocation ({ lng, lat }) {
  console.log(lng, lat)
  let url = `http://api.map.baidu.com/geocoder/v2/?callback=renderReverse&location=${lat},${lng}&output=json&pois=1&ak=${
    options.ak
  }`
  return new Promise((resolve, reject) => {
    jsonp(url, {}, (err, data) => {
      if (!err) {
        let _data = Object.assign({}, data.result)
        if (_data.formatted_address && _data.formatted_address.indexOf('安徽省六安市寿县') > -1) {
          _data.cityCode = 250
        }
        delete _data.poiRegions
        delete _data.business
        delete _data.pois
        _data.city = _data.addressComponent.city
        _data.adcode = _data.addressComponent.adcode
        delete _data.addressComponent
        delete _data.roads
        resolve(_data)
      } else {
        reject(err)
      }
    })
  })
}

let bmap = new BaiduMap(options)
export default bmap
