export const up = {
  single: 'http://127.0.0.1/',
  pre: 'http://127.0.0.1/image/',
  scale: 'http://127.0.0.1/image/scale/',
  base64: 'http://127.0.0.1/base64/'
}

const ximgPre =
  process.env.NODE_ENV === 'production'
    ? 'http://127.0.0.1.cn/'
    : 'http://127.0.0.1.cn/'
export const ximg = {
  single: `${ximgPre}up`,
  pre: `${ximgPre}`,
  base64: `${ximgPre}base64`,
  scale: `${ximgPre}`,
  info: `${ximgPre}info?md5=`
}

let typeArray = [
  'String',
  'Function',
  'Array',
  'Number',
  'RegExp',
  'Object',
  'Date',
  'Undefined'
]
let xgs = {}
typeArray.forEach(item => {
  xgs['is' + item] = obj => {
    return Object.prototype.toString.apply(obj) === '[object ' + item + ']'
  }
})
xgs.format = (fmt, date) => {
  let o = {
    'M+': date.getMonth() + 1, // 月份
    'd+': date.getDate(), // 日
    'h+': date.getHours(), // 小时
    'm+': date.getMinutes(), // 分
    's+': date.getSeconds(), // 秒
    'q+': Math.floor((date.getMonth() + 3) / 3), // 季度
    S: date.getMilliseconds() // 毫秒
  }
  if (/(y+)/.test(fmt)) {
    fmt = fmt.replace(
      RegExp.$1,
      (date.getFullYear() + '').substr(4 - RegExp.$1.length)
    )
  }
  for (let k in o) {
    if (new RegExp('(' + k + ')').test(fmt)) {
      fmt = fmt.replace(
        RegExp.$1,
        RegExp.$1.length === 1 ? o[k] : ('00' + o[k]).substr(('' + o[k]).length)
      )
    }
  }
  return fmt
}
xgs.distance = function (distance) {
  if (!xgs.isNumber(distance)) return ''

  if (distance >= 1000) {
    return (distance / 1000.0).toFixed(2) + 'km'
  }
  return distance + 'm'
}

let epTypes = {
  0: '禁用',
  1: '正常',
  2: '未审核',
  3: '审核未通过'
}
xgs.epStatus = type => {
  return epTypes[type]
}

xgs.ERR_OK = 200

export default xgs
