import Vue from 'vue'
import xgs, { ximg } from '@/common/js/util'
/**
 * binding.value: src or {src:'',h:'',w:''}
 */
Vue.directive('img', {
  // 组件更新
  bind (el, binding) {
    if (xgs.isUndefined(binding.value)) return
    if (binding.value === null) return
    el.__timeout__ = setTimeout(() => {
      let val = binding.value
      let src = ''
      if (xgs.isString(val)) {
        src = ximg.pre + val
      } else {
        src = ximg.pre + val.src + '?h=' + val.h + '&w=' + val.w
      }
      el.src = src
    }, 0)
  },
  unbind (el) {
    clearTimeout(el.__timeout__)
    delete el.__timeout__
  }
})

Vue.directive('head', {
  // 组件更新
  bind (el, binding) {
    el.__timeout__ = setTimeout(() => {
      let val = binding.value
      let src = ''
      if (val.src) {
        if (xgs.isString(val)) {
          src = ximg.pre + val
        } else {
          src = ximg.pre + val.src + '?h=' + val.h + '&w=' + val.w
        }
      } else {
      }
      el.src = src
    }, 0)
  },
  unbind (el) {
    clearTimeout(el.__timeout__)
    delete el.__timeout__
  }
})

Vue.directive('distance', {
  bind (el, binding) {
    let val = xgs.distance(binding.value)
    el.innerHTML = val
  }
})
