import Vue from 'vue'
import Time from '@/common/js/time'

import xgs from '@/common/js/util'

Vue.directive('time', {
  // 组件更新
  bind (el, binding) {
    el.innerHTML = Time.getFormatTime(new Date(+binding.value))
    el.__timeout__ = setInterval(function () {
      el.innerHTML = Time.getFormatTime(new Date(+binding.value))
    }, 500)
  },
  unbind (el) {
    clearInterval(el.__timeout__)
    delete el.__timeout__
  }
})
/**
 * binding.value: src or {src:'',h:'',w:''}
 */
Vue.directive('datetime', {
  // 组件更新
  bind (el, binding) {
    el.innerHTML = xgs.format('yyyy-MM-dd hh:mm:ss', new Date(+binding.value))
  }
})
