// The Vue build version to load with the `import` command
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.
import Vue from 'vue'
import App from './App'
import { router } from './router'
import BaiduMap from 'vue-baidu-map'
import {
  Badge,
  BadgeGroup,
  Row,
  Col,
  Button,
  Cell,
  CellGroup,
  Icon,
  NavBar,
  Tabbar,
  TabbarItem,
  Checkbox,
  CheckboxGroup,
  Field,
  NumberKeyboard,
  PasswordInput,
  RadioGroup,
  Radio,
  Search,
  Switch,
  NoticeBar,
  Actionsheet,
  Dialog,
  PullRefresh,
  Picker,
  Toast,
  Swipe,
  SwipeItem,
  Lazyload,
  Card,
  Tab,
  Tabs,
  List,
  Circle,
  Panel,
  Tag,
  Popup,
  Uploader,
  Steps,
  Step,
  GoodsAction,
  GoodsActionBigBtn,
  GoodsActionMiniBtn,
  SubmitBar,
  Area,
  Rate,
  Sku,
  DatetimePicker
} from 'vant'
import '@/style/icon.css'
import Mint from 'mint-ui'
import 'mint-ui/lib/style.min.css'
import store from '@/store'

import '@/directive/img'
import '@/directive/time'

import gallery from '@/components/img-vuer/gallery'

Vue.use(gallery, {
  swipeThreshold: 150 // default 100 ,new in 0.12.0
})
Vue.use(require('vue-wechat-title'))
Vue.use(BaiduMap, {
  // ak 是在百度地图开发者平台申请的密钥 详见 http://lbsyun.baidu.com/apiconsole/key */
  ak: 'rqAh2byzFT7FKGSHpkcgqvNQ'
})
Vue.use(Mint)
Vue.config.productionTip = false

Vue.use(Badge)
  .use(BadgeGroup)
  .use(Row)
  .use(Col)
  .use(Button)
  .use(Cell)
  .use(CellGroup)
  .use(Icon)
  .use(NavBar)
  .use(Tabbar)
  .use(TabbarItem)
  .use(Checkbox)
  .use(CheckboxGroup)
  .use(Field)
  .use(NumberKeyboard)
  .use(PasswordInput)
  .use(RadioGroup)
  .use(Radio)
  .use(Search)
  .use(Switch)
  .use(Actionsheet)
  .use(Dialog)
  .use(PullRefresh)
  .use(Picker)
  .use(Toast)
  .use(Swipe)
  .use(SwipeItem)
  .use(Lazyload, {})
  .use(Card)
  .use(Tab)
  .use(Tabs)
  .use(List)
  .use(Circle)
  .use(Panel)
  .use(Tag)
  .use(Popup)
  .use(Uploader)
  .use(Steps)
  .use(Step)
  .use(GoodsAction)
  .use(GoodsActionBigBtn)
  .use(GoodsActionMiniBtn)
  .use(SubmitBar)
  .use(Area)
  .use(Rate)
  .use(Sku)
  .use(NoticeBar)
  .use(DatetimePicker)
/* eslint-disable no-new */
new Vue({
  el: '#app',
  router,
  store,
  components: { App },
  template: '<App/>'
})
