import Vue from 'vue'
import Vuex from 'vuex'

import {
  getToken,
  setToken,
  removeToken,
  getCatas,
  setCatas,
  getCataL1,
  getCataL2,
  getLocation,
  setLocation,
  changeLocation,
  getFoundType,
  setFoundType,
  getUser,
  setUser,
  removeUser,
  setEntity,
  getEntity,
  removeEntity
} from '@/common/js/cookie'

Vue.use(Vuex)
const store = new Vuex.Store({
  state: {
    user: getUser(),
    token: getToken(),
    catas: getCatas(),
    catas1: getCataL1(),
    catas2: getCataL2(),
    location: getLocation(),
    foundType: getFoundType(),
    entity: getEntity(),
    recruitScrollY: 0
  },
  mutations: {
    logout (state) {
      removeToken()
      removeUser()
      removeEntity()
    },
    login (state, user) {
      setToken(user['x-token'])
      setUser(user)
      if (user.entity) {
        setEntity(user.entity)
      }
    },
    setCata (state, catas) {
      setCatas(catas)
    },
    _setLocation (state, lt) {
      setLocation(lt)
    },
    changeLocation (state, { cityCode, city }) {
      let l = getLocation()
      if (l) {
      } else {
        l = {}
      }
      l.city = city
      l.cityCode = cityCode
      changeLocation(l)
    },
    _setFoundType (state, type) {
      setFoundType(type)
    },
    changeRecruitScrollY (state, recruitScrollY) {
      state.recruitScrollY = recruitScrollY
    }
  },
  actions: {},
  modules: {},
  getters: {
    token: state => state.token,
    user: state => state.user,
    entity: state => state.entity,
    catas: state => state.catas,
    catas1: state => state.catas1,
    catas2: state => state.catas2,
    location: state => state.location,
    foundType: state => state.foundType,
    recruitScrollY: state => state.recruitScrollY
  }
})

export default store
